var SimpleProtocol=new function(){
	var dataQ=[];
	var sensorQ=[];
	var isFoundP=false;
	var isFoundHeader=false;
	var dataCount=-1;
	var dataSize=-1;
	var checkSumC=0;
	var curId=-1;
	var isEnable=false;
	var isPowerOn=false;
	var self=this;
	this.R200=100000;
//	this.isEAV=false;
	this.TypeNormal=0;
	this.TypeEAV=1;
	this.TypeRYO=2;
	var assignIdCntr=0;
	var _isAssignIdOK = false;
	var _isAssignIdWait=false;		// AssignID cycle is launched and waiting for simple protocol
	var	isAssignIdLaunched=false;
	var _assignIdStartTime=-1;		// AssignID cycle launch time
	this.DeviceType=self.TypeNormal;
	this.isUPP=false;			// UPP(USB Polling Protocol)
	this.isUPPNew=function() {
		this.isUPP=true;
	}
	this.enable=function(_isEnable) {
		_isAssignIdOK=false;
		isEnable=_isEnable;
	}
	
	this.powerOn=function(_isPowerOn) {
		console.log("SimpleProtocol.js powerOn="+_isPowerOn);
		isPowerOn=_isPowerOn;
		sensorQ=[];
		dataQ=[];
		sth=stateHeader.idle;
		st=state.idle;
		this.isFound=false;
		curId=-1;
		assignIdCntr=0;
		_isAssignIdOK = false;
		isAssignIdLaunched=false;
		_isAssignIdWait=false;		
	}
//	this.isEnable=function() {
//		return isEnable;
//	}
	
	this.isAssignIdOK=function() {
		return _isAssignIdOK;
//		return true;
	}
	
	this.getEavP0=function(){
		return this.R200*3/500;
	}
	
	this.assignID=function(_name, _unit, _desc) {
//		if(!isEnable || (assignIdCntr>=2)) {
		console.log("assignID start, _isAssignIdOK="+_isAssignIdOK+", isEnable="+isEnable+", isPowerOn="+isPowerOn+", _isAssignIdWait="+_isAssignIdWait);
		if(!isEnable || !isPowerOn) {
			return;
		}
		var _cur=new Date().getTime();
		if(_isAssignIdWait) {
			if((_cur-_assignIdStartTime)>3000) {
//				console.log("assignID waiting time-out start time="+_assignIdStartTime)
				_isAssignIdWait=false;
			}
			else {
//				console.log("assignID waiting..start time="+_assignIdStartTime+", _cur="+_cur)
			}
			return;
		}
		else {
//			console.log("assignID wait start.., start time="+_assignIdStartTime);
			_isAssignIdWait=true;
			_assignIdStartTime=_cur;
		}
		console.log("assignID, name="+_name+", unit="+_unit+", desc="+_desc);
		for(var i=0;i<sensorQ.length;i++) {
			if(sensorQ[i].name==_name) {
//				return "Hello, "+_name+" is old sensor";
				sensorQ.splice(i,1);
//				return;
			}
		}
		var _nameLength=_name.length;
		var _l=(4+_name.length).toString(16);
		var _cmd="04:01:"+_l+":33:CC:"+sensorQ.length.toString(16)+":"+_name.length.toString(16);
		for(i=0;i<_name.length;i++) {
			_cmd+=":"+_name.charCodeAt(i).toString(16);
		}
		var _ret=oha_api.ApiCmdWr(_cmd);
//		console.log("_ret="+_ret+", _cmd="+_cmd);
		if(_ret=="OK") {
			var sensorObj={
				name:_name,
				unit:_unit,
				desc:_desc
			}
			console.log("assignID OK");
			isAssignIdLaunched=true;
//			_isAssignIdOK = true;
			sensorQ.push(sensorObj);
//			return "Hello, "+_name+" is new sensor";
		}
//		else {
//			assignIdCntr++;
//		}
	}
	
	const stateHeader={
		idle:-1,
		foundP:0,
		id:1,
		count:2,
		found:3
	}
	const state={
		idle:-1,
		data:0,
		checkSum:1
	}
	var sth=stateHeader.idle;
	var st=state.idle;
	
	this.getData=function(_dataArray, _name, _unit, _desc, _raw, _ryo) {
		console.log("SimpleProtocol.getData("+_dataArray+", "+_name+", "+_unit+", "+_desc+", "+_raw+", "+_ryo+")");
	}
	
	var _startT=-1;
	const Vref=2.506;
	
	this.pushD=function(_in)	{
//		if(!isEnable && assignIdCntr>=2) {
		if(!isEnable || assignIdCntr>=2 || !isPowerOn) {
//			console.log("SimpleProtocol.pushD quit, isEnable="+isEnable+", assignIdCntr="+assignIdCntr);
			return;
		}
//		assignIdCntr++;
//		console.log("pushD("+_in.toString(16)+"), stateHeader="+sth+", state="+st)
		switch(sth) {
			case stateHeader.idle:
				isFoundP=false;
				isFoundHeader=false;
				if(_in==0x5A) {
					sth=stateHeader.foundP;
					_startT=new Date().getTime();
				}
				break;
			case stateHeader.foundP:
				if((_in&0x7f)==0x25) {	//Sometimes bit 7 can't send H.
					sth=stateHeader.id;
					isFoundP=true;
				}
				else{
					if(_in!==0x5A) {
						sth=stateHeader.idle;
					}
				}
				break;
			case stateHeader.id:
				isFoundP=false;
				dataSize=((_in>>4)&0x3)+1;
				curId=_in&0x07;
//				console.log("get ID="+curId);
				sth=stateHeader.count;
				break;
			case stateHeader.count:
				dataCount=_in;
//				console.log("get count="+dataCount);
				isFoundHeader=true;
				sth=stateHeader.idle;
				break;
		}
		switch(st) {
			case state.idle:
				if(isFoundHeader) {
					st=state.data;
					checkSumC=0;
				}
				break;
			case state.data:
				if(isFoundHeader) {
					checkSumC=0;
				}
				dataQ.push(_in);
				checkSumC+=_in;
//				console.log("dataQ.length="+dataQ.length+", dataCount="+dataCount+", checkSumC="+checkSumC);
				if(dataQ.length>=dataCount*dataSize) {
					if(dataQ.length>dataCount*dataSize) {
						dataQ=dataQ.slice(0, dataCount*dataSize);
					}
					st=state.checkSum;
					checkSumC=(256-checkSumC&0xff)&0xff;
//					console.log("Data OK, checkSum="+checkSumC);
				}
				break;
			case state.checkSum:
				if(checkSumC==_in) {
					console.log("CheckSum OK, curId="+curId);
//					console.log("name="+sensorQ[curId].name+", unit="+sensorQ[curId].unit+"desc="+sensorQ[curId].desc)
					if(isAssignIdLaunched) {
						_isAssignIdOK=true;
					}
					var _period=new Date().getTime()-_startT;
//					console.log("SimpleProtocol checksum ok, dataCount="+dataCount+", checkSumC="+checkSumC+", period="+_period+"ms");
//					console.log("CheckSum OK, dataQ="+dataQ);
					var newDataQ=[];
					var _raw=null;
					var _ryo=null;
					if(self.isUPP && self.DeviceType==self.TypeEAV) {
						var refADC=512;		// Ideal ADC data for reference voltage=2.5V(default)
					}
					for(var i=0;i<dataQ.length;i+=dataSize) {
//						console.log("SimpleProtocol.pushD, self.DeviceType="+self.DeviceType+", self.isUPP="+self.isUPP);
						if(self.DeviceType==self.TypeEAV) {
							if(self.isUPP) {
								var _d=0;
								for(var j=0;j<dataSize;j++) {
									_d=_d+(dataQ[i+j]<<(j*8));
//									console.log("(i,j)=("+i+","+j+", dataQ["+(i+j)+"]="+dataQ[i+j]+", _d="+_d);
								}
//								console.log("i="+i+", dataSize="+dataSize+", _d="+_d);
								if(i==0) {
									refADC=_d;
//									console.log("Read refADC="+refADC);
									var dx30=0;
									var dx2=0;
								}
								else {
									var k=(i/dataSize);
									switch(k%2) {
										case 0:		// x30 data, the 2nd data(besides refADC)
											dx30=_d;
//											var _voll=getVoll(refADC, dx2, dx30);
											var _voll=getVollByR(refADC, dx2, dx30);
//											console.log("get _voll="+_voll+", refADC="+refADC+", dx2="+dx2+", dx30="+dx30);
											if(isNaN(_voll)) {
												console.log("voll is NaN, dx2="+dx2+", dx30="+dx30);
											}
											else {
												newDataQ.push(_voll);
											}
											break;
										case 1:		// x2 data, the 1nd data(besides refADC)
											dx2=_d;
											break;
									}
								}
							}
							else {
								var _d=0;
								for(var j=0;j<dataSize;j++) {
									_d=_d*0x100+dataQ[i+j];
								}
								_raw=Math.floor(((62500-600*_d)/(6*_d)));
								if(_raw==Infinity) {
									_raw="N.C.";
								}
								else if(_raw>=1000) {
									_raw=(_raw/1000)+"K"
								}
								_ryo=(1200/(3125/(3*_d)-4)).toFixed(0);		// Current, Ibody
	//							1200/(3125/(3*measureV)-4)
								newDataQ.push(_d);
							}
						}
						else {
							for(j=0;j<dataSize;j++) {
								newDataQ.push(dataQ[i+j]);
							}
						}
					}
//					console.log("SimpleProtocol cp0a newDataQ="+newDataQ);
					if(sensorQ[curId]==undefined) {
//						console.log("sensorQ[curId] is undefined, curId="+curId+", sensorQ="+sensorQ);
						dataQ=[];
						st=state.idle;						
						return;
//						this.getData(newDataQ, "Name", "Unit", "Description", _raw, _ryo);
					}
					else {
						this.getData(newDataQ, sensorQ[curId].name, sensorQ[curId].unit, sensorQ[curId].desc, _raw, _ryo);
					}
					_period=new Date().getTime()-_startT;
//					console.log("SimpleProtocol cp1 dataCount="+dataCount+", period="+_period+"ms");
				}
				else if(isFoundHeader) {
					st=state.data;
					checkSumC=0;
//				   console.log("CheckSum ok");
				}
				else {
				   console.log("CheckSum Error!!Expected="+checkSumC.toString(16)+", Read="+_in.toString(16));
				}
				dataQ=[];
				st=state.idle;
				break;
		}
//		return isFound;
	}
		
//	const ADC30MAX=780;
	const ADC30MAX=750;
	function getVoll(adcRef, adcx2, adcx30) {
		var _voltage=0;			// Calculated voltage, unit = mA
//		console.log("getVoll, adcRef="+adcRef+", adcx2="+adcx2+", adcx30="+adcx30);
		if(adcx30>ADC30MAX) {
			_voltage=adcx2*Vref*1000/(adcRef*2);
		}
		else {
			_voltage=adcx30*Vref*1000/(adcRef*31);
		}
		return (_voltage*100)/(103.9*12);
	}
						   
	function getVollByR(adcRef, adcx2, adcx30) {
		var _voltage=0;			// Calculated voltage, unit = mA
//		console.log("getVollByR, adcRef="+adcRef+", adcx2="+adcx2+", adcx30="+adcx30);
//		if(adcx30>ADC30MAX) {
//			_voltage=adcx2*Vref*1000/(adcRef*2);
//		}
//		else {
//			_voltage=adcx30*Vref*1000/(adcRef*31);
//		}
		if(adcx30>ADC30MAX) {
			_voltage=adcx2*Vref/(adcRef*2);
		}
		else {
			_voltage=adcx30*Vref/(adcRef*31);
		}
		_voltage=1.25-_voltage;
		var Rbody=(100000*_voltage)/(1250-_voltage*1000);
//		var Rbody=(100*_voltage)/(1250-_voltage);
		var Ibody=1250/(104.16667+Rbody);		//uA
//		console.log("SimpleProtocol.getVollByR, voltage="+_voltage+"V, Rbody="+Rbody+"Kohm, Ibody="+Ibody+"uA");
		return Ibody*100/12;
	}
						   
}
