(function(){
	var _debugVoll=new function(){
		var SensorName="";
		var Unit="";
		var DescriptText="";
		var LastRaw="";
		var IdleMin=0;	// ms
		var IdleMax=2;	// ms
		var IdleTime=1000;	// ms
		var EndTime=1000;	// ms
		const reactSpeed=5;
		var DataInterval=200;	// ms
		var RasingSlop=10/reactSpeed;	// (voll/Interval)
		var KeepingSlop=-2/reactSpeed;	// (voll/Interval)
		var FallingSlop=-12/reactSpeed;	// (voll/Interval)
		var self=this;
		const VollSt={
			idle:0, 
			raising: 1, 
			keep:2, 
			falling:3,
			end: 4
		};
		var lastD=0;
		var isDevPlugIn=false;
		
		this.simDevPlugIn=function() {
			if(!isDevPlugIn) {
				OHA_DevReady(0, "&oUART:NB:EAV2");
				isDevPlugIn=true;
			}
		}
		
		this.simDevPlugOut=function() {
			if(isDevPlugIn) {
				OHA_DevOff(0);
				isDevPlugIn=false;
			}
		}
		
		this.simVollData=function(_ir, _id) {
			self.simDevPlugIn();
			SensorName="EAV"
			Unit="Voll";
			DescriptText="This sensor is made by OHA";
			var initTime=new Date().getTime();		// State initial time
			var state=VollSt.idle;
			var handle=setInterval(runStateMachine, DataInterval);
			function runStateMachine() {
				var _t=new Date().getTime()-initTime;
				switch(state) {
					case VollSt.idle:
						lastD=IdleMin+Math.floor(Math.random()*(IdleMax-IdleMin));
						if(_t>IdleTime) {
							state=VollSt.raising;
							initTime=new Date().getTime();
						}
						break;
					case VollSt.raising:
						lastD=lastD+RasingSlop;
						if(lastD>_ir) {
							lastD=_ir;
							state=VollSt.keep;
							initTime=new Date().getTime();
						}
						break;
					case VollSt.keep:
						lastD=lastD+KeepingSlop;
						if(lastD<_id) {
							lastD=_id;
							state=VollSt.falling;
							initTime=new Date().getTime();
						}
						break;
					case VollSt.falling:
						lastD=lastD+FallingSlop;
						if(lastD<IdleMax) {
							if(lastD<IdleMin) {
								lastD=IdleMin;
							}
							state=VollSt.end;
							initTime=new Date().getTime();
						}
						break;
					case VollSt.end:
						lastD=IdleMin+Math.floor(Math.random()*(IdleMax-IdleMin));
						if(_t>EndTime) {
							state=VollSt.idle;
							clearInterval(handle);
						}
						break;
				}
				self.sendDataSimple(lastD, "xxxx");
			}
		}
		
		this.setConfig=function(_sensorName, _unit, _description) {
			SensorName=_sensorName;
			Unit=_unit;
			DescriptText=_description;
		}
		
		this.sendDataSimple = function(_value, _raw) {
			if(typeof(_raw)!="undefined") {
				LastRaw=_raw;
			}
			var _sensorStr="oha_sensor "+SensorName+" = "+_value+" "+Unit+" ("+_raw+"),"+DescriptText+".";
			sendToIntr(_sensorStr);
		}
		
		this.sendData=function(_sensorName, _value, _unit, _raw, _description) {
			SensorName=_sensorName;
			Unit=_unit;
			DescriptText=_description;
			LastRaw=_raw;
			var _sensorStr="oha_sensor "+_sensorName+" = "+_value+" "+_unit+" ("+_raw+"),"+_description+".";
			sendToIntr(_sensorStr);
		}
		
		function sendToIntr(_str) {
			var _osensorStr="";
			var _checkSum=0;
			for(var i=0;i<_str.length;i++) {
				var _code=_str.charCodeAt(i)
				_osensorStr+=_code.toString(16)+":";
				_checkSum+=_code;
				_checkSum&=0xffff;
			}
			var _checkSumStr=fill0(_checkSum.toString(16), 4);
//			console.log("ouart_api.simOsensor.sendToIntr, string=\""+_str+"\", checksum="+_checkSum.toString(16));
			_osensorStr+=_checkSumStr.charCodeAt(0).toString(16)+":";
			_osensorStr+=_checkSumStr.charCodeAt(1).toString(16)+":";
			_osensorStr+=_checkSumStr.charCodeAt(2).toString(16)+":";
			_osensorStr+=_checkSumStr.charCodeAt(3).toString(16)+":0";
			OHA_INTR(oha_api.DeviceId, _osensorStr);
			function fill0(_str, _num) {
				var _ret=_str;
				while(_ret.length<_num) {
					_ret="0"+_ret;
				}
				return _ret;
			}
		}
	}
	window.debug_voll=_debugVoll;
})()