importScripts('math.min.js');
importScripts('SimpleProtocol.js');
var oha_config={};
var curData="";
var _isFound=false;
var getDataCntr=0;
if(typeof(console)=="undefined") {
	console=new function() {
		this.log=function(_msg) {
			postMessage({
				action: "console",
				 message: _msg
			});
		}
	}
}

var oha_api=new function() {
	this.runOhaCmd=function(_cmd) {
		postMessage({
			action: "runOhaCmd",
			message: _cmd
		});
	}
	
	this.ApiCmdWr=function(_cmd) {
		postMessage({
			action: "ApiCmdWr",
			message: _cmd
		});
		return "OK";
	}
}

onmessage=function(evt) {
	var _data=evt.data;
//	console.log("oha_intr.onmessage, action="+_data.action);
	switch(_data.action) {
		case "oha_config":
			oha_config=_data.message;
			break;
		case "intr":
			runIntr(_data.message);
			break;
		case "SimpleProtocol":
			switch(_data.message.function) {
				case "config":
					var _config=_data.message.parameters;
					if(_config.hasOwnProperty("enable")) {
						SimpleProtocol.enable(_config.enable);
					}
					if(_config.hasOwnProperty("DeviceType")) {
						SimpleProtocol.DeviceType=_config.DeviceType;
					}
					if(_config.hasOwnProperty("isUPP")) {
						SimpleProtocol.isUPP=_config.isUPP;
					}
					break;
				case "powerOn":
					SimpleProtocol.powerOn(_data.message.parameters.isPowerOn);
					getDataCntr=0;
			}
			break;
	}
}

function runIntr(_recvData) {
	var recvList=_recvData.split(':');
    for(var i=0;i<recvList.length;i++) {
        var _charCode=parseInt(recvList[i], 16);
//		if(!_isFound) {
		SimpleProtocol.pushD(_charCode);
		if(SimpleProtocol.isAssignIdOK()) {
//			console.log("AssignId is OK!!");
			continue;
		}
        if((_charCode==0) || (_charCode==10)) {
            if(!_isFound){
//                console.log("OHA_INTR find illegal string, data="+curData);
                curData="";
                continue;
            }
			
            showOsensor(curData);
            curData="";
            _isFound=false;
//            return;
        }
        curData+=String.fromCharCode(_charCode);
//        console.log("curData=("+curData+")");
        if(_isFound) {
            if(curData.length>512) {
                curData="";
                _isFound=false;
            }
        }
        else {
            var _l0=curData.indexOf("oha_sensor ");
            var _l1=curData.indexOf("oha_http ");
            var _l2=curData.indexOf("oha_sensor_js ");
            var _l3=curData.indexOf("oha_sensor_fn ");
            if((_l0>=0) || (_l1>=0) || (_l2>=0) || (_l3>0)) {
                _isFound=true;
//                console.log("OHA_INTR find key word, data="+curData);
                if(_l0 >=0) {
                    curData=curData.substr(_l0);
                }
                else if(_l1>=0) {
                    curData=curData.substr(_l1);
                }
                else if(_l2>=0){
                    curData=curData.substr(_l2);
                }
                else {
                    curData=curData.substr(_l3);
                }
            }
            else {
                if(curData.length>512) {
                    curData="";
                }
            }
        }
    }    
}

function showOsensor(_str) {
    console.log("showOsensor start:"+_str.length+"("+_str+")");
    var _p=/^(?:oha_sensor)[ \t]+([^=]+)=[ \t]*([^ \t]+)[ \t]+([^ \t]+)[ \t]*[(]([^()]*)[)],(.*)[.]([0-9a-fA-F]{1,4})$/;
    var _p1=/^(?:oha_http)[ \t]*(.*)[.]([0-9a-fA-F]{1,4})$/;
    var _p2=/^(?:oha_sensor_js)[ \t]*(.*)[.]([0-9a-fA-F]{1,4})$/;
//    var _p3=/^(?:oha_sensor_fn)[ \t]*([^=]+)[=][ \t]*([^,]*)[,]((?:[^,]+[,])*[^ \t]+)[ \t]+([^,]*)[,][ \t]*([^.]*)[.]([0-9a-fA-F]{1,4})$/;
    var _p3=/^(?:oha_sensor_fn)[ \t]*([^=]+)[=][ \t]*([^,]*)[,]((?:[0-9.+-]+[,])*[0-9.+-]+)(?:,[Ff]([0-9]))?[ \t]+([^,]*)[,][ \t]*([^.]*)[.]([0-9a-fA-F]{1,4})$/;
    if(_p.test(_str)) {
		console.log("oha_sensor pattern OK");
//        $("#oha_title_2_").text("oha_sensor OK")
        var _name=RegExp.$1;
        var _val=RegExp.$2;
        var _unit=RegExp.$3;
        var _raw=RegExp.$4;
        var _desc=RegExp.$5;
        var _checkSum=RegExp.$6;
//        $(".forDebug").text("p Test OK");
//        if(!checkSum(_name+_val+_unit+_raw+_desc, _checkSum)){
//            return;
//        }
        if(!checkSum(_str)){
			console.log("Error, oha_sensor checkSum fail!");
            return;
        }
//        if(oSensorJsLoaded) {
//            var _obj=new Object();
//            _obj.value=_val;
//            _obj.raw=_raw;
//            _val=osensor_fn.eval(_obj);
//        }
		SimpleProtocol.assignID(_name, _unit, _desc);
		postMessage({
			action:"oha_sensor", 
			name:_name, 
			value:_val, 
			unit:_unit, 
			description: _desc, 
			raw: _raw
		});
//        oSensorShow(_name, _val, _unit, _desc, _raw);
    }
    else if(_p1.test(_str)) {
        var _newUrl=RegExp.$1;
        if(!checkSum(_str)) {
            console.log("oha_http check sum fail");
            return;
        }
        console.log("oha_http protocol is found!!("+_newUrl+")")
        
        if(!_newUrl.startsWith("http://") && !_newUrl.startsWith("https://")){
            _newUrl="http://"+_newUrl;
        }
        if(bgUrl!==_newUrl) {
            bgUrl=_newUrl;
            _url=encodeURI(bgUrl)
            oha_api.runOhaCmd("oha://updateBgUrl_"+_url);
            if(oha_config.simVirtualDevice) {
                $(".urlSection").text(bgUrl);
            }
        }
//        else {
//            alert(bgUrl+" is updated before");
//        }
    }
    else if(_p2.test(_str)) {   //oha_sensor_js
        var _jsUrl=RegExp.$1;
        getJs1(_jsUrl);
//        if(checksum(_str)) {
//            getJs1(_jsUrl);
//        }
//        if(!checkSum(_str)) {
//            console.log("oha_osensor_js checksum fail");
//            return;
//        }
//        $.ajax({url:_jsUrl, dataType:"script"});      //Load JS file
//        oSensorJsLoaded=true;
    }
    else if(_p3.test(_str)) {
        var _sname=RegExp.$1;
        var _func=RegExp.$2;
        var _param=RegExp.$3.split(",");
        var _floor=RegExp.$4;
        var _unit=RegExp.$5;
        var _desc=RegExp.$6;
//        $(".forDebug").text("p3 Test OK");
        if(!checkSum(_str)) {
            console.log("oha_osensor_fn checksum fail");
            return;
        }
        try{
            osensor_fn=math.compile(_func);
            var _pObj=new Object();            
            for(var i=0;i<_param.length;i++) {
                _pObj[String.fromCharCode(97+i)]=parseFloat(_param[i]);
            }
//            oha_api.showToast("_pObj.a="+_pObj.a);
            var _round=0;
            if(_floor.length!==0) {
                _round=parseInt(_floor);
            }
            var _value=math.round(osensor_fn.eval(_pObj),_round);
            oSensorShow(_sname, _value, _unit, _desc);
            
        }catch(e){
            if(oha_config.debug_mode) {
                alert(e.message);
            }
            else {
                oha_api.showToast("Js function load fail!!");
            }
        }
    }
//    console.log("showOsensor end:"+_str.length+"("+_str+")");
}

function checkSum(_str){
    var _cs=0;
    var _p=/^(.+[.])([0-9A-Fa-f]{1,4})$/;
    if(!_p.test(_str)) {
        return false;
    }
    var _strRaw=RegExp.$1;
    for(i=0;i<_strRaw.length;i++){
//        if(oha_config.ignoreCheckSum) {
//            console.log("char["+i+"]=\""+_str.charAt(i)+"\", code="+_str.charCodeAt(i));
//        }
        _cs+=_strRaw.charCodeAt(i);
    }
    _cs&=0xffff;
//    _cs^=0xffff;
    var _expect=parseInt(RegExp.$2,16);
    if(_cs==_expect) {
        return true;
    }
    else {
       console.log("checksum fail, _str="+_str+", expect="+RegExp.$2+", checksum="+_cs.toString(16));
        if(oha_config.ignoreCheckSum) {
            return true;
        }
        return false;
    }
}

SimpleProtocol.getData=function(_dataArray, _name, _unit, _desc, _raw, _ryo){
	var _oldCntr=getDataCntr+1;
//	getDataCntr+=_dataArray.length;
//	console.log(_oldCntr+":"+getDataCntr+", SimpleProtocol.getData="+_dataArray);
	postMessage({
			action: "SimpleGetData",
			message: {
				data:_dataArray, 
				name: _name,
				unit: _unit, 
				description:_desc, 
				raw: _raw, 
				ryo: _ryo
			}
	});
}

