//console.log("oha_timer definition")
(function ($) {
    $.fn.oha_timer=function(_opt) {
        var _css="<style>\
.ohaTimerContainer .ohaTimerValue{\
    position:absolute;\
    width:100%;\
    height:100%;\
    left:0;\
    top:0;\
}\
        </style>";
        var self=this;
        var ModeOptions={
            countup:"countup",
            countdown:"countdown", 
        };
        var _default={
            mode: ModeOptions.countdown, 
            maxTime:-1, 
            minTime:0,        
            setTime:600,
            stepTime:60,
            timeup: function() {
                console.log('timeup!!')
            }, 
        }
        if(_opt.mode==ModeOptions.countup) {
            if(typeof _opt.setTime == "undefined"){
                _default.setTime=0;
            }
        }
        $.extend(_default, _opt);
        $('head').append(_css);
        var startT, curT, remainSec;
        var curPastSec;
        var timerH;     // Timer handler
        var timeSet=_default.setTime;
        this.max=_default.maxTime;
        this.min=_default.minTime;
//        this.each(function() {
//            console.log("hello, oha_timer");
//        });
       if(typeof _t!=="undefined") {
            var _tx=parseFloat(_t);
            if(_tx > 0) {
                this.setTime(_tx);
            }
        }
        if(typeof _max!=="undefined") {
            var max=parseInt(_max);
            if(max >0) {
                this.max=max;
            }
        }
        var lastSetTime=timeSet;
        var lastPauseTime=timeSet;
        console.log("oha_timer conductor timeSet="+timeSet);
    //    $(init);

//        this.timeup=function() {
//            console.log('this.timeup')
//    //        timeup();
//        }

        this.setTime=function(_t) {
            if(typeof _t=="undefined") {
                _t=_default.setTime;
            }
            timeSet=_t;
            lastSetTime=_t;
            lastPauseTime=_t;
            remainSec=_t;
            show(timeSet);
//            $(self).text(formatTime(timeSet));
        };
        
        this.setMax=function(_max) {
            if(typeof _max == "undefined") {
                console.log("oha_timer.setMax has no set time");
                return;
            }
            var max=parseInt(_max);
            if(max >0) {
                this.max=max;
            }
        }

         this.setMin=function(_min) {
            if(typeof _min == "undefined") {
                console.log("oha_timer.setMin has no set time");
                return;
            }
            var min=parseInt(_min);
            if(min >0) {
                this.min=min;
            }
        }

       this.incTime=function(_ts) {
            var t=_default.stepTime;    // Default = 60sec
            if(typeof _ts!=="undefined") {
                t=_ts;
            }
            if(this.max<0 || (this.max>Math.floor((timeSet+t)/60))) {
                timeSet+=t;
                lastSetTime+=t;
                remainSec+=t;
                show(remainSec);
            }
            else {
                if(typeof oha_api !=="undefined") {
                    if(this.max>0) {
                        oha_api.showToast("Timer max. value arrives");
                    }
                }
            }
           return timeSet;
        }

        this.decTime=function(_ts) {
            var t=_default.stepTime;    // Default = 60sec
            if(typeof _ts!=="undefined") {
                t=parseInt(_ts);
            }
            if(remainSec-t>=this.min*60) {
                timeSet-=t;
                lastSetTime-=t;
                remainSec-=t;
                show(remainSec);
           }
            else {
                if(typeof oha_api !=="undefined") {
                    oha_api.showToast("Invalid operation!!");
                }
            }
            return timeSet;
        }

        this.getRemainTime=function() {
            return remainSec;
        }
        
        this.play=function() {
            startT=new Date().getTime();
            timerH=setInterval(function() {
                checkTime()
            }, 250);
        }

        this.pause=function(){
            clearInterval(timerH);
            if(_default.mode==ModeOptions.countdown) {
                lastSetTime=remainSec;
            }
            else {
                lastPauseTime=lastPauseTime+curPastSec;
            }
        }

        this.stop=function(){
            stop();
        }

        this.redraw=function() {
            console.log("oha_timer.redraw()")
            var _h=$(self).height();
            var _w=$(self).width()/3;
            var _x=(_w>_h)?_h:_w;
            $(self).find(".ohaTimerValue").css({"line-height":_h+"px","font-size":_x+"px"});
//            console.log("set ohaTimerValue, line-height="+_h+"px, font-size="+_x+"px");
        }

        function init () {
    //        console.log(timerContainer+","+setTime+","+formatTime(setTime));
            if(_default.mode==ModeOptions.countdown) {
                remainSec=_default.setTime;
            }
            else {
                curPastSec=_default.setTime;
            }
            $(self).addClass("ohaTimerContainer")
            $(self).append("<div class='ohaTimerValue'>"+formatTime(timeSet)+"</div>");
//            $(timerContainer).text(formatTime(timeSet));
            self.redraw();
        }
        
        function stop() {
            clearInterval(timerH);
            lastSetTime=timeSet;
            remainSec=timeSet;
            lastPauseTime=0;
            show(timeSet);
//            $(self).find(".ohaTimerValue").text(formatTime(timeSet));
        }

        function checkTime() {
            curT=new Date().getTime();
            var _pastSec=Math.floor((curT-startT)/1000);
            var _remain=lastSetTime-_pastSec;
    //        console.log('hello, checkTime, _remain='+_remain+", remainSec="+remainSec)
            if(_default.mode==ModeOptions.countdown) {
                if(_remain !==remainSec) {
                    remainSec=_remain;
        //            if(remainSec<0) {
        //                remainSec=0;
        //            }
        //            $(timerContainer).text(formatTime(remainSec));
                    show(remainSec);
                }
                if(remainSec<=0) {
                    console.log("oha_timer stop")
                    stop();
                    _default.timeup();
                }
            }
            else {
                if(_pastSec !==curPastSec) {
                    curPastSec=_pastSec;
                    if(curPastSec>99*60) {
                        curPastSec=0;
                    }
                    show(lastPauseTime+_pastSec);
                }
            }
        }

    //    function timeup() {
    //        console.log('timeup')
    //        this.timeup();
    //    }
        function show(_t) {
            $(self).find(".ohaTimerValue").text(formatTime(_t));
        }

        function formatTime(_sec) {
            var min = Math.floor(_sec / 60);
            sec = _sec - (min * 60);
            /*hundredths = pad(time - (sec * 100) - (min * 6000), 2)*/;
            return (min > 0 ? pad(min, 2) : "00") + ":" + pad(sec, 2);
        }
    //    $(window).load(function() {
    //        this.init();
    //    })

        function pad(number, length) {
            var str = '' + number;
            while (str.length < length) {str = '0' + str;}
            return str;
        }

        $(init());
        return this;
    }
})(jQuery);
