(function(_jq){
    var termHtml='\
            <div class="debugBar">\
                <div class="barBtnDiv0 barBtnDiv">\
                    <button type="button" class="barBtn barBtn0">115200 bps</button>\
                </div>\
                <div class="barBtnDiv1 barBtnDiv">\
                    <button type="button" class="barBtn barBtn1"><span class="uartOff textActive">OFF</span>/<span\ class="uartOn">ON</span></button>\
                    <button type="button" class="barBtn barBtn1x itemHide"><span class="loopOn">ON</span>/<span\ class="loopOff textActive">OFF</span></button>\
                </div>\
                <div class="barBtnDiv2 barBtnDiv">\
                    <button type="button" class="barBtn barBtn2">Clear</button>\
                </div>\
                <div class="barBtnDiv3 barBtnDiv">\
                    <button type="button" class="barBtn barBtn3"><span class="uartHex textActive">HEX</span>/<span class\ ="uartAsc">ASC</span></button>\
                </div>\
            </div>\
            <div class="debugOut">\
                <textarea  class="outputPanel"></textarea>\
            </div>\
            <div class="debugInput">\
                <input class="inputArea" type="text">\
                <div class="prefix">TX></div>\
                <div class="inBtnDiv">\
                    <div class="crBtn inBtn"></div>\
                    <div class="sendBtn inBtn"></div>\
                </div>\
            </div>\
    ';
    
    var _css="<style>\
        .oUartTerm .debugBar {\
            position:absolute;\
            top:0;\
            left:0;\
            height:6%;\
            width:100%;\
            background-color:#a0a0a0;\
        }\
        .oUartTerm .barBtnDiv {\
            position:absolute;\
            top:0;\
            width:25%;\
            height:100%;\
            font-size:2vh;\
        }\
        .oUartTerm .barBtnDiv.barBtnDiv0 {\
            left:0;\
        }\
        .oUartTerm .barBtnDiv.barBtnDiv1 {\
            left:25%;\
        }\
        .oUartTerm .barBtnDiv.barBtnDiv2 {\
            left:50%;\
        }\
        .oUartTerm .barBtnDiv.barBtnDiv3 {\
            left:75%;\
        }\
        .oUartTerm .barBtn {\
            width:100%;\
            height:100%;\
            border-radius:1vw;\
            padding:0;\
            font-size:2.5vh;\
        }\
        .oUartTerm .textActive {\
            color:red;\
        }\
        .oUartTerm .debugInput {\
            position:absolute;\
            top:94%;\
            left:0;\
            width:100%;\
            height:6%;\
            font-size:4vw;\
        }\
        .oUartTerm .debugInput.asciiMode .inputArea{\
            width:58%;\
        }\
        .oUartTerm .inputArea {\
            position: absolute;\
            width: 73%;\
            height: 100%;\
            top: 0;\
            left: 0;\
            padding-left:12%;\
            border-width:0;\
            color: black;\
            background-color: #d0d0d0;\
        }\
        .oUartTerm .debugOut {\
            position:absolute;\
            top:6%;\
            left:0;\
            height:88%;\
            width:100%;\
            background-color:#e0e0e0;\
        }\
        .oUartTerm .outputPanel{\
            height: 100%;\
            width: 100%;\
            display: inline-block;\
            vertical-align: middle;\
            background-color: white;\
            border-style: solid;\
            border-width: 0;\
            border-color: gray;\
            background-color: #A0A0A0;\
            color: white;\
            text-align: left;\
            overflow: auto;\
            text-overflow: clip;\
            font-size:2.5vh;\
            font-family: \"Courier New\", monospace, Arial, sans-serif;\
        }\
        .oUartTerm .prefix::before{\
            content:'';\
            display:inline-block;\
            height:100%;\
            width:0;\
            vertical-align:middle;\
        }\
        .oUartTerm .prefix {\
            position: relative;\
            background-color: transparent;\
            display: inline-block;\
            /* margin: auto; */\
            text-align: center;\
            width: 10%;\
            height: 100%;\
            vertical-align:middle;\
            color: black;\
        }\
        .oUartTerm div.inBtnDiv {\
            position: absolute;\
            width:15%;\
            height: 100%;\
            right:0;\
            top:0;\
        }\
        .oUartTerm .debugInput.asciiMode div.inBtnDiv {\
            width: 30%;\
        }\
        .oUartTerm div.inBtn {\
            position: absolute;\
            display: inline-block;\
            width: 100%;\
            height: 100%;\
            background-repeat: no-repeat;\
            background-size: contain;\
            background-position: center;\
        }\
        .oUartTerm .debugInput.asciiMode div.inBtn {\
            width: 50%;\
        }\
        .oUartTerm .debugInput.asciiMode div.crBtn {\
            display:block;\
        }\
        .oUartTerm div.crBtn {\
            display:none;\
            top: 0;\
            left: 0;\
            background-image: url(files/CR.png);\
        }\
        .oUartTerm .debugInput.asciiMode div.sendBtn {\
            left:50%;\
        }\
        .oUartTerm div.sendBtn {\
            top: 0;\
            left: 0;\
            background-image: url(files/SendBtn.png);\
        }\
    </style>";
    
    var _panelLineNo=0;
    _jq.fn.oUartTerm=function(_opt) {
        var self = this;
        var loopBackPrev=-1;
        var loopBackEnd=false;
        var LoopTestEn=false;
        var LoopTestModeOpt={
            UnSet: -1, 
            TX:0,
            RX:1,
            TX_RX:2,
            RX_TX:3, 
        };
        var LoopTestMode=LoopTestModeOpt.UnSet;
        var loopInitData=0;
        var loopCount=8192;
        var txLoopCount=0;
        var rxLoopCount=0;
        var testLineNo=0;
        var rxFailCount=0;
        var loopDataMode="mode0";
        var loopTestName="";
        var loopDataValue=0x80;
        var outDataCount=0;
        var isCheckFailStop=false;
        var debugMode=false;
        var startTestTime=0;
        var isPowerOn=false;

//        var loopTestIntv=1000;
        var txLoopIntv=50;            // The interval for loopback test TX packet
        var rxCheckIntv=100;            // The interval for loopback test RX checking
        var loopRxBuf=[];           // RX buffer for loopback test
//        var loopTestHandler;
        $(this).addClass("oUartTerm");
//        $('head').append('<link rel="stylesheet" href="oha_api/oha_uart_terminal.css" type="text/css" />');
        $('head').append(_css);
        var _default={
            baudRate: 9600,
            enable: false, 
            mode: "hex", 
            cookieEnable: false,        // if true, the previous setting will be used
            sendHex: function(_in){    // Function to send the input area
                console.log("sendHex:"+_in);
            }, 
            sendAscii: function(_in){
                console.log("sendAscii:"+_in);
            }, 
            maxLine:1000000,
        };
        var loopBackTestMode=false;
        var rxStr=""
        var rxStrL=0;
		// variables add by Tom 20170503...
		var all_str="";
		var update_timer=-1;
		// end of Tom.
        var cookieOpt={
            baudRate: {
                key: 'baudRate',
                default : '19200',
                options: ['9600','19200','38400','57600','115200'],
            }, 
            enable: {        // On/off initial
                key: 'enable',
                default: 'true', 
                options: {
                    enable:'true', 
                    disable:'false',
                }, 
            }, 
            uartMode: {
                key: 'umode',
                default: 'hex', 
                options: {hex:'hex',
                          ascii:'asc',
                         }, 
            },
            txInputString: {
                key: 'txLast', 
                default: '', 
                options: {},
            }, 
        }
        function cookieInit() {
            var _cookieObj=new Object();
            if(typeof _default.baudRate!=="undefined"){
                _cookieObj.baudRate=parseInt(oha_api.cookieRead(cookieOpt.baudRate.key, _default.baudRate));
            }
            else {
                _cookieObj.baudRate=parseInt(oha_api.cookieRead(cookieOpt.baudRate.key, cookieOpt.baudRate.default));
            }
            if(oha_api.cookieRead(cookieOpt.enable.key, cookieOpt.enable.default)=="true") {
                _cookieObj.enable=true;
            }
            else {
                _cookieObj.enable=false;
            }
            _cookieObj.mode=oha_api.cookieRead(cookieOpt.uartMode.key, cookieOpt.uartMode.default);
            _cookieObj.txInputString=oha_api.cookieRead(cookieOpt.txInputString.key, cookieOpt.txInputString.default);
            return _cookieObj;
        }
        var isDevPlugIn=false;
        _jq.extend(_default, _opt);
        $(this).append(termHtml);
        if(_default.cookieEnable) {
            _jq.extend(_default, cookieInit());
        }
        var debugInPressed=false;
        var keyEnable=false;  
        this.devPlugIn=function() {
//            console.log("oUartTerm.devPlugIn()")
        //                    alert("devPlugIN("+_default.baudRate+")")
            isDevPlugIn=true;
            _panelLineNo=0;
            if(_default.enable) {
                oha_api.ApiCmdWr("04:04");
                powerOff();
                powerOn();
            }
            else {
                powerOff();
            }
            setBaudrate(_default.baudRate);
            if(loopBackTestMode) {
                loopBackEnd=false;
            }
            switch(LoopTestMode) {
                case LoopTestModeOpt.UnSet:
                    $(self).find(".debugBar .barBtn").removeAttr("disabled");
                    $(self).find(".debugBar .barBtn1x").attr("disabled", "disabled");
                    break;
                default:
                    $(self).find(".debugBar .barBtn").attr("disabled", "disabled");
                    $(self).find(".debugBar .barBtn1x").removeAttr("disabled");
                    $(self).find(".debugBar .barBtn2").removeAttr("disabled");
                    break;
                               }

        }
        
        this.devPlugOut=function() {
            isDevPlugIn=false;
            if(loopBackTestMode) {
                loopBackEnd=true;
            }
        //                    console.log("oUartTerm.devPlugOut()")
            if(LoopTestEn) {
                insertOutData("Device is Plugged out.., stop the test!")
                self.stopLoopTest();
            }
            $(this).find(".debugBar .barBtn1x").attr("disabled","disabled");
            $(this).find(".debugBar .barBtn2").attr("disabled","disabled");
        }
        this.showRX=function(_recvList) {
            console.log("showRX("+LoopTestMode+")")
            if(LoopTestMode>0) {
               return;
            }
            if(_default.mode=="asc") {
                for(i=0;i<_recvList.length;i++) {
                    var _charCode=parseInt(_recvList[i], 16);
                    if(_charCode==0 || _charCode==10) {
                        if(rxStr.length!==0) {
                            insertOutData(rxStr);
                        }
                        rxStr="";
                    }
                    else if(rxStr.length > 512) {
                        insertOutData(rxStr);
                        rxStr="";
                    }
                    else {
                        rxStr+=String.fromCharCode(_charCode);
                    }
        //                            rxStr+=String.fromCharCode(_charCode);
                }
        //                        insertOutData("RX(ASC):\""+rxStr+"\"");
            }
            else {
                var _lastL=rxStrL;
                rxStrL+=_recvList.length;
                for(i=0;i<_recvList.length;i++) {
        //                            if(i%8==0) {
        //                                if(i==0) {
        //                                    rxStr+="RX(HEX):";
        //                                }
        //                                else {
        //                                    rxStr+="<br>RX(HEX):";
        //                                }
        //                            }
                    if(_recvList[i].length==1) {
                        rxStr+="0"+_recvList[i];
                    }
                    else {
                        rxStr+=_recvList[i];
                    }
                    if((i+_lastL)%4==3) {
                        rxStr+=" ";
                    }
                    if((i+_lastL)%16==15) {
                        var rxStrHeader=outDataCount.toString(16);
                        for(j=rxStrHeader.length;j<4;j++) {
                            rxStrHeader="0"+rxStrHeader;
                        }
                        if(loopBackTestMode) {
                            if(!loopBackEnd) {
                                insertOutData((rxStrHeader+" "+rxStr).toLocaleUpperCase());
                                loopBackCheck(_recvList);
                            }
                        }
                        else {
                            insertOutData((rxStrHeader+" "+rxStr).toLocaleUpperCase());
                        }
                        outDataCount+=16;
                        if(outDataCount==0x10000) {
                            outDataCount=0;
                        }
                        rxStrL-=16;
                        rxStr="";
                    }
                }
        //                        insertOutData(rxStr);
            }
        }
        
        this.loopBackTest=function(_enable, _stopFunction) {
            if(typeof _stopFunction=="function") {
                self.stop=_stopFunction;
            }
            if(loopBackTestMode==_enable){
                return;
            }
            loopBackTestMode=_enable;
            if(_enable) {
                $("#title_content").text("Debug Mode");
                 _jq(this).find(".uartHex").addClass("textActive");
                 _jq(this).find(".uartAsc").removeClass("textActive");
                _default.mode=cookieOpt.uartMode.options.hex;
                _default.baudRate=57600;
                _default.enable=true;
                _default.txInputString="55 AA 08 20 78 11 0A";
            }
            else {
                $("#title_content").text("OHA Controller");
                $.extend(_default, cookieInit());
                if(_default.mode==cookieOpt.uartMode.options.ascii){
                    _jq(this).find(".uartHex").removeClass("textActive");
                    _jq(this).find(".uartAsc").addClass("textActive");
                }
                _default.baudRate=parseInt(oha_api.cookieRead(cookieOpt.baudRate.key, _default.baudRate));
                if(oha_api.cookieRead(cookieOpt.enable.key, cookieOpt.enable.default)=="true") {
                    _default.enable=true;
                }
                else {
                    _default.enable=false;
                }
            }
            $(".barBtn.barBtn0").text(_default.baudRate+" bps");
            setBaudrate(_default.baudRate);
            if(_default.enable) {
                _jq(self).find(".uartOn").addClass("textActive");
                _jq(self).find(".uartOff").removeClass("textActive");
                powerOn();
            }
            else {
                _jq(self).find(".uartOn").removeClass("textActive");
                _jq(self).find(".uartOff").addClass("textActive");
                powerOff();
            }
            $(".inputArea").val(_default.txInputString);

        }
        
        this.setLoopParam=function(_intv, _count, _mode, _dataValue) {
            console.log("oUart.setLoopParam("+_intv+", "+_count+", "+_mode+", "+_dataValue+")");
            txLoopIntv=_intv;
            loopCount=Math.ceil(_count/8);
            loopDataMode=_mode;
            loopDataValue=_dataValue;
        }

        this.stopLoopTest=function() {
            $(this).find(".debugBar").css({"opacity":"1.0"});
//            $(this).find(".debugBar button").removeAttr("disabled");
//            $(this).find(".inputArea").removeAttr("disabled");
            $(this).find(".debugBar .barBtn1x .loopOn").removeClass("textActive")
            $(this).find(".debugBar .barBtn1x .loopOff").addClass("textActive")
            console.log("LoopTestEn is false")
            LoopTestEn=false;
            powerOff();
            insertOutData(loopTestName+" is stopped.")
            showResult();
//            if(loopTestHandler!=null) {
//                LoopTestEn=false;
//                clearTimeout(loopTestHandler);
//                loopTestHandler=null;
//                insertOutData("stoping LoopTest")
//            }
//            oha_api.ApiCmdWr("04:01:08:55:AA:02:FF:FF:FF:FF:FF");   // Stop command
        }
        
        this.getLoopRxData =function(_dataList) {
            var _d="";
            for(var i=0;i<_dataList.length;i++) {
                _d+=_dataList[i]+":";
            }
//            console.log("getLoopRxData:"+_d);
            loopRxBuf=loopRxBuf.concat(_dataList);
        }
        
        this.LoopTest=function(_en, _mode) {
//            console.log("LoopTest(_en="+_en+", _mode="+_mode+")");
            if(_en) {
                $(this).find(".debugBar button").attr("disabled", "disabled");
                if(isDevPlugIn) {
                    $(this).find(".debugBar .barBtn1x").removeAttr("disabled");
                    $(this).find(".debugBar .barBtn2").removeAttr("disabled");
                }
                else {
                    $(this).find(".debugBar .barBtn1x").attr("disabled", "disabled");
                }
                $(this).find(".debugBar .barBtn1").addClass("itemHide")
                $(this).find(".debugBar .barBtn1x").removeClass("itemHide")
                $(this).find(".debugBar .barBtn1x .loopOn").removeClass("textActive")
                $(this).find(".debugBar .barBtn1x .loopOff").addClass("textActive")
                $(this).find(".inputArea").attr("disabled", "disabled");
                switch(_mode){
                    case 0:
                        loopTestName="oUART Test TX";
                        break;
                    case 1:
                        loopTestName="oUART Test RX comparison";
                        break;
                    case 2:
                        loopTestName="oUART Test TX then RX comparison";
                        break;
                    case 3:
                        loopTestName="oUART Test RX then TX";
                        break;
                    default:
                        break;
                            }
                insertOutData(loopTestName+", touch \"ON\" to start")
                LoopTestMode=_mode;
            }
            else {
                $(this).find(".debugBar .barBtn1").removeClass("itemHide")
                $(this).find(".debugBar .barBtn1x").addClass("itemHide")
                insertOutData("Terminal mode")
                if(isDevPlugIn) {
                    $(self).find(".debugBar .barBtn").removeAttr("disabled");
                    $(self).find(".debugBar .barBtn1x").attr("disabled", "disabled");
                    $(this).find(".inputArea").removeAttr("disabled");
                    if(LoopTestEn) {
                        self.stopLoopTest();
                    }
                }
                LoopTestMode=LoopTestModeOpt.UnSet;
            }
        }
        
        this.isLoopTest=function() {
            return LoopTestEn;
        }
        
        function showResult() {
            var _lastTime=new Date().getTime();
            var _time=-1;
            var _period=(_lastTime-startTestTime)/1000;
            var _p=lengthTo8(Math.floor(_period).toString());
            var _rc=lengthTo8((rxLoopCount*8).toString());
            var _tc=lengthTo8((txLoopCount*8).toString());
            var _trdiff=(Math.abs(txLoopCount-rxLoopCount))*8;
            var _rdr=lengthTo8((Math.floor(rxLoopCount*8/_period)).toString());
            var _tdr=lengthTo8((Math.floor(txLoopCount*8/_period)).toString());
            var _fc=lengthTo8(rxFailCount.toString());
//            var _fr=lengthTo8(Math.floor(rxFailCount*12.5/rxLoopCount).toString()+"%");
            var _fr=lengthTo8((rxFailCount*12.5/rxLoopCount).toFixed(4)+"%");
            switch(LoopTestMode) {
                case LoopTestModeOpt.TX:
                    insertOutData(_tc+" TX bytes<br>"+_p+" seconds<br>"+_tdr+" bytes/second<br><br>")
                    break;
                case LoopTestModeOpt.RX:
                    insertOutData(_rc+" RX bytes<br>"+_p+" seconds<br>"+_rdr+" bytes/second<br>"+_fc+" bytes fail<br>"+_fr+" fail rate<br><br>")
                    break;
                case LoopTestModeOpt.TX_RX:
                    if(_trdiff!==0) {
                        insertOutData(lengthTo8(_trdiff.toString())+" TX/RX byte difference")
                    }
                    insertOutData(_tc+" TX bytes<br>"+_p+" seconds<br>"+_tdr+" bytes/second<br><br>")
                    insertOutData(_rc+" RX bytes<br>"+_p+" seconds<br>"+_rdr+" bytes/second<br>"+_fc+" bytes fail<br>"+_fr+" fail rate<br><br>")
                    break;
                case LoopTestModeOpt.RX_TX:
                    if(_trdiff!==0) {
                        insertOutData(lengthTo8(_trdiff.toString())+" TX/RX byte difference")
                    }
                    insertOutData(_rc+" RX bytes<br>"+_p+" seconds<br>"+_rdr+" bytes/second<br><br>")
                    insertOutData(_tc+" TX bytes<br>"+_p+" seconds<br>"+_tdr+" bytes/second<br><br>")
                    break;
                default:
                    break;
                               }
        }
        
        function lengthTo8(_in) {
            for(var i=_in.length;i<8;i++) {
                _in="&nbsp"+_in;
            }
            return _in;
        }
        
        function getLoopData() {
            if(loopRxBuf.length<8) {
                throw -1;
            }
            var _ret=loopRxBuf.slice(0,8);
            loopRxBuf=loopRxBuf.slice(8,loopRxBuf.length);
            console.log("getLoopData:"+_ret)
            return _ret;
        }
        
        this.startLoopTest=function() {
            console.log("startLoopTest, en="+LoopTestEn+", mode="+LoopTestMode)
            LoopTestEn=true;
            loopRxBuf=[];
            loopInitData=0;
            txLoopCount=0;
            rxLoopCount=0;
            testLineNo=0;
            rxFailCount=0;
//            loopCount=0;
            startTestTime=new Date().getTime();
            switch(LoopTestMode) {
                case LoopTestModeOpt.TX:           // TX only
                    if(debugMode) {
                        insertOutData("starting LoopTest(TX only)")
                    }
//                    oha_api.ApiCmdWr("04:01:08:55:AA:01:00:FF:FF:FF:FF")
//                    startLoopTestR(true);
                    txLoop(0);
                    break;
                case LoopTestModeOpt.RX:           // RX only
                    if(debugMode) {
                        insertOutData("starting LoopTest(RX only)")
                    }
                    rxCheck(0, false);
//                    oha_api.ApiCmdWr("04:01:08:33:CC:01:01:FF:FF:FF:FF")
//                    startLoopTestR(false);
                    break;
                case LoopTestModeOpt.TX_RX:           // TX then RX
                    if(debugMode) {
                        insertOutData("starting LoopTest(TX then RX)")
                    }
                    txLoop(0);
                    rxCheck(0, false);
//                    oha_api.ApiCmdWr("04:01:08:55:AA:01:02:FF:FF:FF:FF")
//                    var _outCmd="04:01:08:00:01:02:03:04:05:06:07";
//                    oha_api.ApiCmdWr(_outCmd);
//                    startLoopTestR(true);
                    break;
                case LoopTestModeOpt.RX_TX:           // RX then TX
                    if(debugMode) {
                        insertOutData("starting LoopTest(RX then TX)")
                    }
                    rxCheck(0, true);
//                    oha_api.ApiCmdWr("04:01:08:55:AA:01:03:FF:FF:FF:FF")
//                    startLoopTestR(false);
                    break;
                default:
            }
        }
        
        function txLoop(_count) {
            var _count1=_count;
//            console.log("txLoop("+_count1+")");
            for(var j=0;j<32;j++) {
                var _outCmd="04:01:08";
                for(var i=0;i<8;i++) {
                    if(loopDataMode=="mode1") {
                        var _d=loopDataValue.toString(16);
                        _outCmd+=":"+_d;
                    }
                    else {
                        var _d=(_count1+i).toString(16);
                        _outCmd+=":"+_d;
                    }
                }
                txLoopCount++;
                if(txLoopCount%32==0) {
                    testLineNo++;
                    insertOutData(testLineNo+" TX test("+txLoopCount*8+" bytes)");

                }
                console.log("txLoop("+_outCmd+")");
                oha_api.ApiCmdWr(_outCmd);
    //            stusCheck();
                _count1+=8;
                if(_count1==256) {
                    _count1=0;
                }
            }
            if(LoopTestEn) {
                if(txLoopCount>=loopCount) {
                    if((LoopTestMode==LoopTestModeOpt.TX) || (LoopTestMode==LoopTestModeOpt.RX_TX)) {
                        insertOutData("TX complete!!"+loopCount*8+"bytes/"+txLoopCount+"times is passed!");
                        self.stopLoopTest();
                    }
                    else if(LoopTestMode==LoopTestModeOpt.TX_RX) {
                        setTimeout(function(){
                            if(LoopTestEn) {
                                insertOutData("Time-out!!");
                                self.stopLoopTest();
                            }
                        }, 1000);
                    }
                }
                else {
                    setTimeout(function(){txLoop(_count1)}, txLoopIntv);
                }
            }
//            else {
//                self.stopLoopTest();
//            }
        }
        
        function rxCheck(_count, _isSentBack) {
//            console.log("rxCheck("+_count+", "+_isSentBack+")");
            if(typeof _isSentBack =="undefined") {
                _isSentBack=false;
            }
            try{
                while(LoopTestEn) {
//                    console.log("rxCheck before getLoopData");
                    var _loopData=getLoopData();
//            console.log("rxCheck("+_count+", "+_isSentBack+")");
                    var _dStr="";
//                    console.log("_loopData.length="+_loopData.length)
                    for(var j=0;j<_loopData.length;j++) {
//                        console.log("_loopData"+j+"="+_loopData[j])
                        if(j==0) {
                            _dStr+=_loopData[0];
                        }
                        else {
                            _dStr+=":"+_loopData[j];
                        }
                    }
//                    insertOutData("rxCheck getLoopData:"+_dStr);
                    var _isPktFail=false;
                    var _expStr="";
                    for(var i=0;i<8;i++) {
                        _curD=parseInt(_loopData[i],16);
                        if(_count<16) {
                            _expStr+="0"+_count.toString(16);
                        }
                        else {
                            _expStr+=_count.toString(16);
                        }
                        if(i==3) {
                            _expStr+=" ";
                        }
                        var _expD=_count;
                        if(loopDataMode=="mode1") {
                            _expD=loopDataValue;
                        }
                        if(_curD!=_expD) {
                            _isPktFail=true;
                            rxFailCount++;
                            var _dStr1="";
                            for(var j=0;j<_loopData.length;j++) {
                                if(_loopData[j].length==1) {
                                    _dStr1+="0"+_loopData[j];
                                }
                                else {
                                    _dStr1+=_loopData[j];
                                }
                                if(j==3) {
                                    _dStr1+=" ";
                                }
                            }
                            insertOutData("Err RX="+_dStr1+", ("+ _expD.toString(16)+","+i+","+rxLoopCount+")");
                            if(isCheckFailStop) {
                                LoopTestEn=false;
                                self.stopLoopTest();
                                return _curD;
                            }
                            else {
                                if(loopDataMode=="mode0") {
                                    _count= _curD;
                                }
                            }
                        }
                        _count++;
                        if(_count==256) {
                            _count=0;
                        }
                    }
                    if(_isPktFail) {
//                        insertOutData("Should&nbsp&nbspRX="+_expStr);
                        insertOutData("Ref RX="+_expStr);
                    }
                    if(_isSentBack) {
                        var _outCmd="04:01:08:"+_dStr;
                        console.log("rxCheck ApiCmdWr("+_outCmd+")");
                        oha_api.ApiCmdWr(_outCmd);
                    }
                    rxLoopCount++;
                    if(rxLoopCount%32==0) {
                        testLineNo++;
                        insertOutData(testLineNo+" RX test("+rxLoopCount*8+" bytes)");
                    }
                    if(rxLoopCount>=loopCount) {
//                        if(debugMode) {
                            insertOutData("RX Check Test complete!!");
//                        }
                        LoopTestEn=false;
                        self.stopLoopTest();
//                        showResult();
                    }
//                    _count+=8;
//                    if(_count==256) {
//                        _count=0;
//                    }
                }
            }
            catch(e) {
                // No data
//                console.log("Exception is catched!!");
                if(LoopTestEn) {
                    if(e<0) {
                        setTimeout(function(){rxCheck(_count, _isSentBack)}, rxCheckIntv);
                    }
                    else {
                        setTimeout(function(){rxCheck(e, _isSentBack)}, rxCheckIntv);

                    }
                }
                else {
                    self.stopLoopTest();
                }
            }
        }
        
        function stusCheck() {
            console.log("stusCheck()");
            try{
                var _loopData=getLoopData();
                if((_loopData[0]==0x55) && (_looopData[1]==0xAA)) {
                    var _errCount=_loopData[2]+_loopData[3]*256+_loopData[4]*65536;
                    insertOutData("Error, count="+_errCount);
                    LoopTestEn=false;
                }
            }
            catch(e) {
            }
        }
        
//        function startLoopTestR() {
//            if(typeof _isTxFirst =="undefined") {
//                _isTxFirst=false;
//            }
//            console.log("startLoopTestR LoopTestMode="+LoopTestMode+", LoopTestEn="+LoopTestEn);
//            var _outCmd="04:01:08";
//            for(var i=0;i<8;i++) {
//                var _d=(loopInitData+i).toString(16);
//                _outCmd+=":"+_d;
//            }
////            if(_isTxFirst) {
////                loopInitData+=8;
////                if(loopInitData==256) {
////                    loopInitData=0;
////                }
////                if(loopCount==1000000) {
////                    insertOutData("TX send complete!!");
////                    LoopTestEn=false;
////                }
////                loopCount+=1;
////            }
//            switch(LoopTestMode) {
//                case 0:           // TX only
//                    goNextLoop();
//                    oha_api.ApiCmdWr(_outCmd);
//                    console.log("ApiCmdWr("+_outCmd+")");
//                    if(LoopTestEn) {
//                        loopTestHandler=setTimeout(startLoopTestR, loopTestIntv);
//                    }
//                    break;
//                case 1:           // RX only
//                    if(checkLoopData()) {
//                        goNextLoop();
//                    }
//                    if(LoopTestEn) {
//                        loopTestHandler=setTimeout(startLoopTestR, loopTestIntv);
//                    }
//                    break;
//                case 2:           // TX then RX
//                    if(checkLoopData()) {
//                        oha_api.ApiCmdWr(_outCmd);
//                        goNextLoop();
//                    }
//                    if(LoopTestEn) {
//                        loopTestHandler=setTimeout(startLoopTestR, loopTestIntv);
//                    }
//                    break;
//                case 3:           // RX then TX
//                    if(checkLoopData()) {
////                        oha_api.ApiCmdWr(_outCmd);
//                        goNextLoop();
//                    }
//                    if(LoopTestEn) {
//                        loopTestHandler=setTimeout(startLoopTestR, loopTestIntv);
//                    }
//                    break;
//                default:
//            }
//        }
        
//        function goNextLoop() {
//            loopInitData+=8;
//            if(loopInitData==256) {
//                loopInitData=0;
//            }
//            if(loopCount==loopCount) {
//                insertOutData("Test complete!!");
//                LoopTestEn=false;
//            }
//            loopCount+=1;
//            if(loopCount%10==0) {
//                insertOutData(loopCount+" loop test pass!!");
//            }
//        }
        
//        function checkLoopData() {
//            console.log("checkLoopData, loopCount="+loopCount+", loopInitData="+loopInitData);
//            try{
//                if(typeof _isRxFirst =="undefined") {
//                    _isRxFirst=false;
//                }
//                var _loopData=getLoopData();
//                for(var i=0;i<8;i++) {
//                    _curD=parseInt(_loopData[i],16);
//                    if(_curD!=(loopInitData+i)) {
//                        insertOutData("Loop Data Check Error!!");
//                        var _dStr="";
//                        for(var j=0;j<8;j++) {
//                            if(j==0) {
//                                _dStr+=_loopData[0];
//                                continue;
//                            }
//                            _dStr+=":"+_loopData[j];
//                        }
//                        insertOutData("Count="+loopCount+", index:"+i+", Expected:0x"+(loopInitData+i).toString(16));
//                        insertOutData("receive data="+_dStr);
//                        LoopTestEn=false;
//                        return false;
//                    }
//                }
////                if(_isRxFirst) {
////                    loopInitData+=8;
////                    if(loopInitData==256) {
////                        loopInitData=0;
////                    }
////                    if(loopCount==1000000) {
////                        insertOutData("Test complete!!");
////                        LoopTestEn=false;
////                        return true;
////                    }
////                    loopCount+=1;
////                }
//                return true;
//            }
//            catch(e) {
//                // No data
//                return false;
//            }
//        }
        
        this.stop=function() {
            _default.sendHex(["00"]);
        }
        
        function loopBackCheck(_dataList) {
            var _prev=0;
            for(var i=0;i<8;i++) {
                var _cur=parseInt(_dataList[i], 16);
                if(i!==0) {
                    if(loopDataMode=="mode0") {
                        var _exp=(_prev+1);
                        if(_exp==256) {
                            _exp=0;
                        }
                        if(_exp !==_cur) {
                            insertOutData("Data fail("+i+"):Exp/Real="+_exp+"/"+_cur);
                            loopBackEnd=true;
                            self.stop();
                        }
                    }
                    else {
                        if(_cur!==loopDataValue) {
                            insertOutData("Data fail("+i+"):Exp/Real="+loopDataValue+"/"+_cur);
                            loopBackEnd=true;
                            self.stop();
                        }
                    }
                }
                if(loopBackEnd) {
                    break;
                }
                _prev=_cur;
            }
            if(loopBackPrev!==-1) {
                if((loopBackPrev+8)%256 !== _prev) {
                    insertOutData("Data fail, previous last data="+loopBackPrev.toString(16)+", current last data="+_prev.toString(16));
                    loopBackEnd=true;
                    self.stop();
                }
//                else {
//                    insertOutData("Pass, loopBackPrev="+loopBackPrev.toString(16)+", current="+_prev.toString(16));
//                }
            }
            loopBackPrev=_prev;
        }
		
		//Tom 20170503.. process outputPanel GUI update. 
		var lastScrollTop = 0;
		var current_data_begin=0;
		var current_data_end=0;
		function update_outputPanel()
		{
			
			if (update_timer != -1)
			{
				clearInterval(update_timer);
				update_timer = -1;
			}
			
			
			
			var panel = _jq(self).find(".outputPanel")[0];
			var isScrollBottom=false;


			//console.log("panel.scrollTop="+panel.scrollTop+"panel.innerHeight"+panel.offsetHeight+"panel.scrollHeight="+panel.scrollHeight);
			if ((panel.scrollTop+panel.offsetHeight+2)>=panel.scrollHeight) isScrollBottom = true;
			if ( isScrollBottom || (panel.innerHTML.length == 0))
			{
				// update data.
				if (all_str.length > 10000)
				{
					panel.innerHTML = all_str.slice(-10000);
					current_data_begin = all_str.length-10000;
					current_data_end = all_str.length;
				}
				else
				{
					panel.innerHTML = all_str;
					current_data_begin = 0;
					current_data_end = all_str.length;
				}
				
				// scroll to the last line.
				panel.scrollTop = panel.scrollHeight;
				lastScrollTop = panel.scrollTop;
			}
			else
			{
				//console.log("not scroll bottom!");
				if (panel.innerHTML.length == all_str.length) return;
				if (lastScrollTop == panel.scrollTop) return;
				var oldScrollHeight = panel.scrollHeight;
				var currentScrollTop = panel.scrollTop;
				
				if (lastScrollTop < panel.scrollTop) // user scroll down
				{
					// load all contents from current begin to data end.
					current_data_end = all_str.length;
					var new_content = all_str.slice(current_data_begin, current_data_end);
					panel.innerHTML = new_content;
					panel.scrollTop = currentScrollTop;
					//console.log("panel.scrollTop="+panel.scrollTop);
				} 
				else if (lastScrollTop > panel.scrollTop) // usser scroll up.
				{
					if (panel.scrollTop < panel.offsetHeight) // almost scroll to top, load more data.
					{
						current_data_begin = current_data_begin - 10000;
						if (current_data_begin < 0) current_data_begin = 0;
						var new_content = all_str.slice(current_data_begin, current_data_end);
						//console.log("current_data_begin="+current_data_begin+"current_data_end="+current_data_end);
						panel.innerHTML = new_content;
						var newScrollHeight = panel.scrollHeight;
						panel.scrollTop = currentScrollTop + newScrollHeight - oldScrollHeight;
					}
					
				}
				
				lastScrollTop = panel.scrollTop;
			}
		}

       function insertOutData (inStr, _isConcat) {
		   //console.log("enter insertOutputData");
		   //var t0 = performance.now();
           if(typeof _isConcat=="undefinede") {
               _isConcat=false;
           }
            if(inStr.length==0) {
                return;
            }
			//for (var i = 0; i < 100; i++)
			//{
           if(_isConcat) {
               //var _last=_jq(self).find(".outputPanel div").last();
               //_last.text(_last.text()+inStr);
                all_str = all_str+inStr+"\r";
				//console.log(new_str);
				//_jq(self).find(".outputPanel")[0].innerHTML = all_str;
           }
           else {
			   //console.log(_jq(self).find(".outputPanel"));
			    if (all_str.length>0)
					all_str = all_str+"\r"+inStr;
				else
					all_str = inStr;
				//console.log(new_str);
				//_jq(self).find(".outputPanel")[0].innerHTML = all_str;
				
				if (all_str.length > (_default.maxLine) * 1.1)
					all_str=all_str.slice(-_default.maxLine);

               
			   /*
                _jq(self).find(".outputPanel").append("<div>"+inStr+"</div>");
//               _panelLineNo++;
               _panelLineNo=_jq(self).find(".outputPanel div").size();
               if(_panelLineNo>_default.maxLine*1.1) {
    //                   _jq(self).find(".outputPanel div").remove();
                   _jq(self).find(".outputPanel div:lt(_default.maxLine*0.2)").remove();
//                   _panelLineNo-=50;
               }
    //               var _h=_jq(self).find(".outputPanel div").eq(0).height();
               _jq(self).find(".outputPanel").scrollTop(_default.maxLine-1); 
			   */
           }
			//}
		   if (update_timer==-1)
		   {
			   update_timer = setInterval(update_outputPanel, 500);
		   }
			
//                var _cn=_jq(self).find(".outputPanel").children().size();
//                if(_cn > config_setting.MaxLine) {
//                    _jq(self).find(".outputPanel div:lt("+(_cn-config_setting.MaxLine)+")").remove();
//                }
//                var _h=_jq(self).find(".outputPanel div").eq(0).height();
//                _jq(self).find(".outputPanel").animate({scrollTop:_h*config_setting.MaxLine}, 200); 

			//var t1 = performance.now();
			//console.log("insertOutData " + (t1 - t0) + " milliseconds.");
        }

        function init() {
            var _baudrate=parseInt(_default.baudRate);
            setBaudrate(_baudrate);
            setEnable(_default.enable);
            setMode(_default.mode);
            $(self).find(".debugInput .inputArea").val(_default.txInputString);
        }

        function setBaudrate(_baud) {
            var _baudX=parseInt(_baud);
            var _baudIdx=0;
            switch(_baudX) {
                case 9600:
                    _baudIdx=0;
                    break;
                case 19200:
                    _baudIdx=1;
                    break;
                case 38400:
                    _baudIdx=2;
                    break;
                case 57600:
                    _baudIdx=3;
                    break;
                case 115200:
                    _baudIdx=4;
                    break;
                default:
                    _baudIdx=0;
                    break;
            }
            if(isDevPlugIn) {
//                    alert("setBaudrate("+_baud+")");
//                    console.log("oha_api.ApiCmdWr(04:00:"+_baudIdx+":02:08)");
                oha_api.ApiCmdWr("04:00:"+_baudIdx+":02:08");
            }
            _jq(self).find(".barBtn.barBtn0").text(_baud+" bps");
        }

        function setEnable(_enable) {
            if(_enable) {
                _jq(self).find(".uartOn").addClass("textActive")
                _jq(self).find(".uartOff").removeClass("textActive")
            }
            else {
                _jq(self).find(".uartOff").addClass("textActive")
                _jq(self).find(".uartOn").removeClass("textActive")
            }
        }

        function setMode(_mode) {
            if(_mode=="asc") {
                _jq(self).find(".uartHex").removeClass("textActive");
                _jq(self).find(".uartAsc").addClass("textActive");
                _jq(self).find(".debugInput").addClass("asciiMode");
            }
            else {
                _jq(self).find(".uartHex").addClass("textActive");
                _jq(self).find(".uartAsc").removeClass("textActive");
                _jq(self).find(".debugInput").removeClass("asciiMode");
            }
        }

        function checkData(_mode, _e) {
//                console.log("checkData(mode="+_mode+", code="+_e.which+", _in="+_in)
            if(_mode!=="asc") {
                var content=String.fromCharCode(_e.which);
                var patt=/[ 0-9a-fA-F]/;
                if(patt.test(content)){
                    return  true;
                }else{
                    alert("Error! input Hex number separates with space!");
                    return false;
                }
            }
            return true;
        }

        function toHexFormat (_inStr) {
            inStr=_inStr;
            inStr=inStr.replace(/\S\S/g, function(x) {return x+" "}).trim();
            inStr=inStr.replace(/\s\S(?=(?:$|\s+))/g, function(x) {return " 0"+x.slice(1,2)+" "});
            inStr=inStr.replace(/^\S$/, function(x) {return "0"+x});
            inStr=inStr.replace(/\s+/g, " ");
            inStr=inStr.toUpperCase();

            return inStr;
        }

        function powerOn() {
            console.log("oUartTerm.powerOn")
            rxStr="";
            rxStr="";
            rxStrL=0;
            if(typeof oha_api!=="undefined") {
                oha_api.ApiCmdWr("02:00:00:05:00:00:AA:AA");
                oha_api.ApiCmdWr("02:01:00:05:00:00:AA")
                isPowerOn=true;
            }
        }
        function powerOff() {
            console.log("oUartTerm.powerOff")
            if(typeof oha_api!=="undefined") {
                oha_api.ApiCmdWr("02:00:00:05:00:00:AA:AA");
                oha_api.ApiCmdWr("02:01:00:05:00:00:55")
                oha_api.ApiCmdWr("04:04");
                isPowerOn=false;
            }
        }
        
		var cmdTimer=-1;
		function intervalSendCmd()
		{
		//	console.log("sendCmd()");
            var _inStr=_jq(self).find(".debugInput .inputArea").val();
            var _inStr1=_inStr.replace(/\s/g, "&nbsp");

            if(_default.mode=="asc") {
                insertOutData(">"+_inStr1);
                _default.sendAscii(_inStr);
            }
            else {
            //    console.log("sendHex:"+_inStr);
                var _hexStr=toHexFormat(_inStr);
				// Tom Test.
				var testStr = _hexStr+new Date().getTime();
				insertOutData(">"+testStr);
                //insertOutData(">"+_hexStr);
                _default.sendHex(_hexStr.split(" "));
                _jq(self).find(".debugInput .inputArea").val(_hexStr);
            }
            oha_api.cookieWrite(cookieOpt.txInputString.key, _inStr);
            if(loopBackTestMode) {
                loopBackPrev=-1;
                loopBackEnd=false;
            }
		}
        function sendCmd() {
			if (cmdTimer==-1)
			{
				cmdTimer = setInterval(intervalSendCmd,100);
			}
			else
			{
				clearInterval(cmdTimer);
				cmdTimer = -1;
			}
        }
		
		
		/*
		function sendCmd() {
			console.log("sendCmd()");
            var _inStr=_jq(self).find(".debugInput .inputArea").val();
            var _inStr1=_inStr.replace(/\s/g, "&nbsp");

            if(_default.mode=="asc") {
                insertOutData(">"+_inStr1);
                _default.sendAscii(_inStr);
            }
            else {
                console.log("sendHex:"+_inStr);
                var _hexStr=toHexFormat(_inStr);
				// Tom Test.
				_inStr = _hexStr+new Date().getTime();
				insertOutData(">"+_inStr);
                //insertOutData(">"+_hexStr);
                _default.sendHex(_hexStr.split(" "));
                _jq(self).find(".debugInput .inputArea").val(_hexStr);
            }
            oha_api.cookieWrite(cookieOpt.txInputString.key, _inStr);
            if(loopBackTestMode) {
                loopBackPrev=-1;
                loopBackEnd=false;
            }
        }
		*/
        
        _jq(self).find(".barBtn.barBtn0").click(function(){
            if(loopBackTestMode) {
                return;
            }
            var _baudTxt=$(this).text();
            var _baud=9600;
            var _pat=/^ *([0-9]+) *bps *$/;
            if(_pat.test(_baudTxt)) {
                switch(RegExp.$1) {
                    case "9600":
                        _baud=19200;
                        break;
                    case "19200":
                        _baud=38400;
                        break;
                    case "38400":
                        _baud=57600;
                        break;
                    case "57600":
                        _baud=115200;
                        break;
                    case "115200":
                        _baud=9600;
                        break;
                    default:
                        _baud=9600;
                }
                $(this).text(_baud+" bps")
                setBaudrate(_baud);
                if(_default.cookieEnable) {
                    oha_api.cookieWrite(cookieOpt.baudRate.key, ""+_baud);
                }
            }
            else {
                $(this).text("9600 bps");
                setBaudrate(_baudrate);
            }
//                console.log($(this).text());
        });
        _jq(self).find(".barBtn.barBtn1").click(function(){
            _jq(this).find(".uartOn,.uartOff").toggleClass("textActive");
            if(_jq(this).find(".uartOn").hasClass("textActive")) {
                // Enable oUART
                console.log("Enable oUART");
                powerOn();
                if(_default.cookieEnable) {
                    oha_api.cookieWrite(cookieOpt.enable.key, cookieOpt.enable.options.enable);
                }
            }
            else {
                // Disable oUART
                console.log("Disable oUART");
                powerOff();
                oha_api.ApiCmdWr("04:04");
                if(_default.cookieEnable) {
                    oha_api.cookieWrite(cookieOpt.enable.key, cookieOpt.enable.options.disable);
                }
            }
        });
        _jq(self).find(".barBtn.barBtn1x").click(function(){
            _jq(this).find("span").toggleClass("textActive");
            if(_jq(this).find(".loopOn").hasClass("textActive")) {  // ON
                rxStr="";
                rxStrL=0;
                powerOn();
                self.startLoopTest();
            }
            else {                      // Off
                powerOff();
                self.stopLoopTest();
            }
        });
        
        _jq(self).find(".barBtn.barBtn2").click(function(){
            //_jq(self).find(".outputPanel div").remove();
			all_str = "";
			_jq(self).find(".outputPanel")[0].innerHTML="";
            testLineNo=0;
            outDataCount=0
        });
        _jq(self).find(".barBtn.barBtn3").click(function(){
            if(loopBackTestMode) {
                return;
            }
            _jq(this).find(".uartHex,.uartAsc").toggleClass("textActive");
            _jq(self).find(".inputArea").val("");
            if(_jq(this).find(".uartHex").hasClass("textActive")) {
                // Hex mode
                console.log("Hex mode");
                _jq(self).find(".debugInput").removeClass("asciiMode");
                _default.mode="hex";
                if(_default.cookieEnable) {
                    oha_api.cookieWrite(cookieOpt.uartMode.key, cookieOpt.uartMode.options.hex);
                }
            }
            else {
                // ASCII
                console.log("Ascii mode");
                _jq(self).find(".debugInput").addClass("asciiMode");
                _default.mode="asc";
                if(_default.cookieEnable) {
                    oha_api.cookieWrite(cookieOpt.uartMode.key, cookieOpt.uartMode.options.ascii);
                }
            }
//                _jq(self).find(".debugInput .inputArea").val("");
        });
        _jq(self).find(".debugInput .sendBtn").click(function(){
            sendCmd();
        });
        
        _jq(self).find(".debugInput .crBtn").click(function(){
                insertOutData("><br>");
                _default.sendAscii(String.fromCharCode(13)+String.fromCharCode(10));            
        });
        
        _jq(self).find(".debugInput .inputArea").keypress(function(e) {
//                console.log("key in "+e.which);
//                if(!keyEnable) {
//                    return;
//                }
            switch(e.which) {
                case 13:        // enter
                    sendCmd();
                    break;
//                    case 32:
////                        _in.text(_in.text()+String.fromCharCode(160));  // &nbsp;
//                        if(_default.mode=="asc") {
//                            _in.text(_cur.val()+String.fromCharCode(160));
//                        }
//                        else {
//                            _in.text(toHexFormat(_cur.val()+String.fromCharCode(e.which)));
//                        }
//                        break;
                default:
                    if(_default.mode=="hex") {
                        if(!checkData(_default.mode, e)) {
//                            console.log("now:"+toHexFormat(_in.text()+String.fromCharCode(e.which)));
//                                _jq(this).val(toHexFormat(_jq(this).val()+String.fromCharCode(e.which)));
                            return false;
                        }
                    }
            }
//               if(e.which!==13) {
//                    if(self.checkData(_default.mode, e, _in.text())) {
//                        _in.text(self.toHexFormat(_in.text()+String.fromCharCode(e.which)));
//                    }
//                }
//                else {
//                    _default.send(_in.text(), _default.mode);
////                    ctrlObj.insertOutData(_in.text());
//                    _in.text("");
//                }
        })
//        _jq(self).find(".inputClipBoard").focusin(function(e) {
////                console.log("focus in:"+e.type);
//            _jq(self).find(".debugInput span").eq(2).addClass("blink");
////                _jq(this).find(".inputClipBoard").focus();
//        });     
//
////            _jq(self).find(".debugInput").focusout(function(e) {
//////                console.log("focus out:"+e.type);
////                _jq(this).find("span").eq(2).removeClass("blink");
//////                _jq(this).find(".inputClipBoard").blur();
////            });
//
//        _jq(self).find(".inputClipBoard").focusout(function(e) {
////                console.log("focus out:"+e.type);
//            _jq(self).find(".debugInput span").eq(2).removeClass("blink");
////                _jq(this).find(".inputClipBoard").focus();
//        });     

        _jq(self).find(".debugInput").keydown(function(e) {
//                console.log("keydown("+e.which+")");               
            if(e.which==8) {
                var _in=_jq(this).find("span").eq(1);
                if(_in.text().length>0) {
                    _in.text(_in.text().slice(0, -1));
                }
            }
        });
//            _jq(document).click(function(){
////                console.log("document is clicked")
//                if(debugInPressed) {
//                    _jq(self).find(".debugInput").find("span").eq(2).addClass("blink");
//                    keyEnable=true;
//                }
//                else {
//                    _jq(self).find(".debugInput").find("span").eq(2).removeClass("blink");
//                    keyEnable=false;
//                }
//                debugInPressed=false;
//            })
//            _jq(self).find(".debugInput").click(function(){
////                console.log("debugInput is clicked")
////                $(this).focus()
//                debugInPressed=true;
//            })

        init();
        return self;
    };
    
})(jQuery);

//function OHA_INTR(_id, _recvData) {
//    
//}
