(function(_jq){
    var waveview_Html='\
				<select class="YType">\
					<option value="low">Low Precision</option>\
					<option value="high">High Precision</option>\
					<option value="fix">Fix Range</option>\
				</select>\
				<select class="MaxY">\
					<option value=1000>MaxY:1000</option>\
					<option value=256>MaxY:256</option>\
					<option value=100>MaxY:100</option>\
				</select>\
				<select class="MinY">\
					<option value=0>MinY:0</option>\
					<option value=-100>MinY:-100</option>\
					<option value=-256>MinY:-256</option>\
					<option value=-1000>MinY::-1000</option>\
				</select>\
				<select class="PageSize">\
					<option value="50">50</option>\
					<option value="100">100</option>\
					<option value="200">200</option>\
					<option value="500">500</option>\
					<option value="1000">1000</option>\
				</select>\
                <canvas  class="waveviewPanel"></canvas>\
    ';
    
    var _css="<style>\
        .oha_waveview .PageSize {\
            position:absolute;\
			  top: 0;\
			  right: 0px;\
			  width: 20%;\
			  height:10%;\
			  outline: 0;\
			  font-size:2vw;\
			  border-width:0.2vw;\
			  border-style:solid;\
			  border-radius:1vw;\
			  border-color:#A0A0A0;\
            background-color:#e0e0e0;\
        }\
        .oha_waveview .YType {\
            position:absolute;\
			  top: 0;\
			  left: 0px;\
			  width: 25%;\
			  height:10%;\
			  outline: 0;\
			  font-size:2vw;\
			  border-width:0.2vw;\
			  border-style:solid;\
			  border-radius:1vw;\
			  border-color:#A0A0A0;\
            background-color:#e0e0e0;\
        }\
        .oha_waveview .MaxY{\
            position:absolute;\
			  top: 0px;\
			  left: 25%;\
			  width: 20%;\
			  height:10%;\
			  outline: 0;\
			  font-size:2vw;\
			  border-width:0.2vw;\
			  border-style:solid;\
			  border-radius:1vw;\
			  border-color:#A0A0A0;\
            background-color:#e0e0e0;\
        }\
        .oha_waveview .MinY{\
            position:absolute;\
			  top: 0px;\
			  left: 45%;\
			  width: 20%;\
			  height:10%;\
			  outline: 0;\
			  font-size:2vw;\
			  border-width:0.2vw;\
			  border-style:solid;\
			  border-radius:1vw;\
			  border-color:#A0A0A0;\
            background-color:#e0e0e0;\
        }\
        .oha_waveview .waveviewPanel{\
            height:100%;\
            width:100%;\
            display: inline-block;\
            vertical-align: middle;\
            background-color: white;\
            border-style: solid;\
            border-width: 0;\
            border-color: gray;\
            background-color: #A0A0A0;\
            color: white;\
            text-align: left;\
            overflow: auto;\
            text-overflow: clip;\
            font-size:2.5vh;\
            font-family: \"Courier New\", monospace, Arial, sans-serif;\
			z-index: 0;\
        }\
    </style>";
	function parseTime(seconds)
	{
		var h;
		var m;
		var s;
		
		s = Math.floor(seconds % 60);
		m = Math.floor((seconds / 60)) %60;
		h = Math.floor(seconds / 3600);
		
		if (h > 0)
			return parseInt(h)+":"+parseInt(m)+"'"+parseInt(s)+"''";
		else if (m>0)
			return parseInt(m)+"'"+parseInt(s)+"''";
		else
			return parseInt(s)+"''";
		
	}

    _jq.fn.oha_waveview=function(_opt) {
        var self = this;
		var count=0;

        $(this).addClass("oha_waveview");
        $('head').append(_css);
        var _default={
			YType:"fix",
			YRange: [1000, 0],
			MaxYSelections:[1000, 256, 0],
			MinYSelections:[0, -100, -256, -1000],
			XPageSize: 50,
			XPageSizeSelections:[50, 100, 200, 500, 1000],
			callback: null
        };
		var chart_data = 
		{
			labels: [],
			datasets: [{
				label: '',
				data: [],
				backgroundColor: 
					'rgba(255, 99, 132, 0.2)'
				,
				borderColor: 
					'rgb(255,99,132)'
				,
				borderWidth: 1
			}]
		};
		var total_data = [];
		var total_info = [];
		var total_timestamp = [];
		var nDisplayStartPos=0;
		var nStartTime = -1;
		var bLockDisplay=false;
		var yPrecise=0;
		var chart_options = {
						scales: {
							yAxes: [{
								ticks: {
									userCallback: function(label, index, labels) {
										if (chart_options.scales.yAxes[0].ticks.max === label) {
											return '';
										}
										return parseFloat(label).toFixed(yPrecise);
									},
									fontSize: window.innerWidth*0.03
								},
								gridLines: {
									display: true ,
									color: "#FFFFFF",
									drawTicks:false
								}
							}],
							xAxes: [{
								ticks: {
									
									autoSkip: false,
									beginAtZero:true,
									userCallback: function(label, index, labels) {
										// when the floored value is the same as the value we have a whole number
										var xgrid_interval = 30; // origin default was 6
										var XPageSizeSelecter = _jq(self).find(".PageSize")[0];
										xgrid_interval = parseInt(XPageSizeSelecter.value/10);
										if ( (index%xgrid_interval) === 0) {
										//	return parseInt(index);//label;
											if (total_timestamp[nDisplayStartPos+index] > 0)
											{
												
												if (index  > xgrid_interval && total_timestamp[nDisplayStartPos+index-xgrid_interval] <= 0) // the first to draw
												{
													return parseTime( Math.floor((total_timestamp[nDisplayStartPos+index]-nStartTime) / 1000));
												}
												else if (index == xgrid_interval)
												{
													return parseTime( Math.floor((total_timestamp[nDisplayStartPos+index]-nStartTime) / 1000));
													
												}
												else if ((index+xgrid_interval) >= MAX_DATA_DISPLAY)
												{
													return parseTime( Math.floor((total_timestamp[nDisplayStartPos+index]-nStartTime) / 1000));
												}
												else
													return "";
												
											}
											else
												return "";
										}
									},
									fontSize: window.innerWidth*0.03
								},
								gridLines: {
									display: true ,
									color: "#FFFFFF",
									drawTicks:false
								}
							}]
						},
						title: { text:''},
						tooltips: {enabled: false},
						// don't draw bezier curve. set tension to 0, 0.4 is for default bezierCurve.
						elements: {
							line: {
								tension: 0
							}
						}
					};
		var chart_plugins = {
			afterDatasetsDraw: function(chart) {
				var ctx = chart.chart.ctx;
				if (typeof ctx == 'undefined') 
				{
					console.log("ctx == undefined");
					return;
				}	
				chart.data.datasets.forEach(function(dataset, i) {
					var meta = chart.getDatasetMeta(i);
					if (meta.hidden)
					{
						return;
					}
					if (typeof (dataset.info) == 'undefined') {
						return;
					}
					{
						meta.data.forEach(function(element, index) {
							
							if (typeof (dataset.info[index]) == 'undefined') {
								return;
							}
							if (typeof(dataset.info[index].info)=='undefined') {
								return;
							}
							if ( dataset.info[index].info.length <= 0 && dataset.info[index].id != nLockAtIndex) {
								return;
							}
							ctx.fillStyle = 'rgb(0, 0, 0)';

//							var fontSize = 16;
							var panel = _jq(self).find(".waveviewPanel")[0];
							var elementHeight = panel.getBoundingClientRect().height;
							var fontSize = elementHeight*0.03;//window.innerWidth*0.03;
							var fontStyle = 'normal';
							var fontFamily = 'Helvetica Neue';
							ctx.font = Chart.helpers.fontString(fontSize, fontStyle, fontFamily);

							// Just naively convert to string for now
							if (typeof(dataset.info[index].info)!='undefined' && dataset.info[index].info.length>0)
							{
								var dataString = dataset.info[index].info.toString();

								// Make sure alignment settings are correct
								ctx.textAlign = 'center';
								ctx.textBaseline = 'middle';

								var padding = 5;
								var position = element.tooltipPosition();
								ctx.fillText(dataString, position.x, position.y - (fontSize / 2) - padding);
							}
							if (bLockDisplay)
							if (dataset.info[index].id == nLockAtIndex)
							{
								var position = element.tooltipPosition();
								ctx.fillStyle = 'rgb(255, 0, 0)';
								ctx.fillText("Lock", position.x, elementHeight/2);//position.y);
							}
						});
					}
				});
			}
		};
		
		
		Chart.defaults.global.animation.duration = 0;
		Chart.defaults.global.maintainAspectRatio = false;
		Chart.defaults.global.title.display = true;
		Chart.defaults.global.legend.display = false;
		Chart.defaults.global.elements.point.radius = 0;
        Chart.defaults.global.defaultFontColor="#FFFFFF";
		var YScaleAllowFloat=false;
		var MAX_DATA_DISPLAY = 50; // current data per page.
		var MAX_DATA_VALUE = 1000; // max data per page, (max of 50, 100, 200, 500, 1000)
		const MAX_DATA_STORED = 1000000;
		var oWaveChart=null;
		var bOptionsChanged = true;
		var bDebugMe = true;
		var nLockAtIndex = -1;
		
		var yRange = [256, 0];
        _jq.extend(_default, _opt);
		var callback = _default.callback;
		_default.callback = undefined;
		
        $(this).append(waveview_Html);
		var ctx = _jq(self).find(".waveviewPanel")[0];
		
		ctx.addEventListener("touchmove", function(event) { wave_touchmove(event);});
		ctx.addEventListener("touchstart", function(event) { wave_touchstart(event);});
		ctx.addEventListener("touchend", function(event) { wave_touchend(event);});
		var XPageSizeSelecter = _jq(self).find(".PageSize")[0];
		XPageSizeSelecter.addEventListener("change", function(event) { XPageSizeChange(event);});
		
		var YType = _jq(self).find(".YType")[0];
		YType.addEventListener("change", function(event) { YTypeChange(event);});
		
		var MaxYSelecter= _jq(self).find(".MaxY")[0];
		MaxYSelecter.addEventListener("change", function(event) { MaxYChange(event);});
		var MinYSelecter= _jq(self).find(".MinY")[0];
		MinYSelecter.addEventListener("change", function(event) { MinYChange(event);});
		MaxYSelecter.style.display = "none";
		MinYSelecter.style.display = "none";
		
		// 20180612, allow user defined y axis range.
		this.SetYRange = function (yMax, yMin)
		{
			if (typeof yMax == 'undefined') 
				yMax = yRange[0];
			if (typeof yMin == 'undefined') 
				yMin = yRange[1];
			
			_default.YRange = yRange = [yMax, yMin];
			MaxYSelecter.value = yRange[0];
			MinYSelecter.value = yRange[1];
		}
		this.SetMaxYSelections = function (options)
		{
			if (typeof options == 'undefined') 
			{
				return;
			}
			if (!Array.isArray(options))
			{
				return;
			}

			_default.MaxYSelections.length=0;
			_default.MaxYSelections = options;
			MaxYSelecter.options.length = 0;
			var $i;
			for($i=0; $i < _default.MaxYSelections.length; $i++)
			{
				var opt = document.createElement("option");
				opt.text = 'Max:'+_default.MaxYSelections[$i];
				opt.value= _default.MaxYSelections[$i];
				MaxYSelecter.add(opt, $i);
			}
			MaxYSelecter.value = yRange[0];
		}
		this.SetMinYSelections = function (options)
		{
			if (typeof options == 'undefined') 
			{
				return;
			}
			if (!Array.isArray(options))
			{
				return;
			}
			_default.MinYSelections.length=0;
			_default.MinYSelections = options;
			MinYSelecter.options.length = 0;
			var $i;
			for($i=0; $i < _default.MinYSelections.length; $i++)
			{
				var opt = document.createElement("option");
				opt.text = 'Min:'+_default.MinYSelections[$i];
				opt.value= _default.MinYSelections[$i];
				MinYSelecter.add(opt, $i);
			}
			MinYSelecter.value = yRange[1];
		}
		this.SetXPageSizeSelections = function (options)
		{
			if (typeof options == 'undefined') 
			{
				return;
			}
			if (!Array.isArray(options))
			{
				return;
			}
			_default.XPageSizeSelections.length=0;
			_default.XPageSizeSelections = options;
			XPageSizeSelecter.options.length = 0;
			var $i;
			var max=-999999;
			for($i=0; $i < _default.XPageSizeSelections.length; $i++)
			{
				var opt = document.createElement("option");
				opt.text = _default.XPageSizeSelections[$i];
				opt.value= _default.XPageSizeSelections[$i];
				XPageSizeSelecter.add(opt, $i);
				if (max < _default.XPageSizeSelections[$i]) max = _default.XPageSizeSelections[$i];
			}
			XPageSizeSelecter.value = MAX_DATA_DISPLAY = _default.XPageSize;
			MAX_DATA_VALUE = max;
		}
		this.SetXPageSize = function (xPageSize)
		{
			if (typeof xPageSize == 'undefined') 
			{
				return;
			}
			XPageSizeSelecter.value = _default.XPageSize = MAX_DATA_DISPLAY = xPageSize;
			nDisplayStartPos=total_data.length-MAX_DATA_DISPLAY;
		}
		this.SetYType = function (yType)
		{
			if (typeof yType == 'undefined') 
			{
				return;
			}
			if (yType=="fix" || yType=="low" || yType=="high")
				YType.value = yType;
			else
				return;
				
			if (YType.value == "fix")
			{
				MaxYSelecter.value = yRange[0];
				MinYSelecter.value = yRange[1];
				MaxYSelecter.style.display = "";
				MinYSelecter.style.display = "";
			}
			else
			{
				if (YType.value == "low") YScaleAllowFloat = false;
				else if (YType.value == "high") YScaleAllowFloat = true;
				MaxYSelecter.style.display = "none";
				MinYSelecter.style.display = "none";

			}
			_default.YType = YType.value;
		}
		
		// 20190704, Center the specified index.
		this.CenterID = function(id)
		{
			if (typeof(id)=='undefined')
				return;
			// id to index.
			var nIndex=-1;
			for (i = 0; i < total_info.length; i++)
			{
				if (typeof(total_info[i].id)=='undefined')
					continue;
				if (total_info[i].id==id) {
					nIndex = i;
					break;
				}
			}
			if (nIndex == -1) return;
			nDisplayStartPos = nIndex - (MAX_DATA_DISPLAY) / 2;
			if (nDisplayStartPos < 0) nDisplayStartPos = 0;
			if ((nDisplayStartPos + MAX_DATA_DISPLAY) > total_data.length) 
				nDisplayStartPos = total_data.length - MAX_DATA_DISPLAY;
			
			chart_data.datasets[0].data.length = 0;
			chart_data.datasets[0].info.length = 0;
			var i;
			if (total_data.length < MAX_DATA_DISPLAY)
			{
				for (i = total_data.length; i < MAX_DATA_DISPLAY; i++)
				{
					chart_data.datasets[0].data.push(total_data[0]);
					chart_data.datasets[0].info.push(total_info[0]);
				}
			}
			bLockDisplay = true;
			UpdateChartOptions();
			UpdateView();
		}

		// 20190709, Lock/Unlock waveview and move view point to center the specified index.
		this.LockViewAtID = function(bLock, id)
		{
			if (typeof(bLock)=='undefined')
				bLock = false;
			if (bLock != false)
				bLock = true;
			if (typeof(id)=='undefined')
				id = -1;
			//	return;
			nLockAtIndex = id;
			// id to index.
			var nIndex=-1;
			if (id < 0) //== -1 )
			{
				if (bLock)
				{
					nIndex = total_info.length-1;
					if (typeof(total_info[nIndex].id)!='undefined')
						nLockAtIndex = total_info[nIndex].id;
				}
				else // !bLock
				{
					if (id == -1)
					{
						// Move to latest data.
						nIndex = total_info.length-1;
						if (typeof(total_info[nIndex].id)!='undefined')
							nLockAtIndex = total_info[nIndex].id;
					} else { // if (id == -2) {
						bLockDisplay = false;
						return;
					}
				}
			}
			else
				for (i = 0; i < total_info.length; i++)
				{
					if (typeof(total_info[i].id)=='undefined')
						continue;
					if (total_info[i].id==id) {
						nIndex = i;
						break;
					}
				}
			nDisplayStartPos = nIndex - (MAX_DATA_DISPLAY) / 2;
			if (nDisplayStartPos < 0) nDisplayStartPos = 0;
			if ((nDisplayStartPos + MAX_DATA_DISPLAY) > total_data.length) 
				nDisplayStartPos = total_data.length - MAX_DATA_DISPLAY;
			
			chart_data.datasets[0].data.length = 0;
			chart_data.datasets[0].info.length = 0;
			var i;
			if (total_data.length < MAX_DATA_DISPLAY)
			{
				for (i = total_data.length; i < MAX_DATA_DISPLAY; i++)
				{
					chart_data.datasets[0].data.push(total_data[0]);
					chart_data.datasets[0].info.push(total_info[0]);
				}
			}
			bLockDisplay = bLock;
			UpdateChartOptions();
			UpdateView();
		}
		
		
		this.SetInfoWithID = function(id, info)
		{
			if (typeof(id)=='undefined')
				return;
			if (typeof(info)=='undefined')
				return;
			for (i = 0; i < total_info.length; i++)
			{
				if (typeof(total_info[i].id)=='undefined')
					continue;
				if (total_info[i].id==id) {
					//console.log("**** setInfoWithID("+id+","+info+"), set to data index="+i);
					total_info[i].info = info;
					return;
				}
			}
		}
		this.Redraw=function()
		{
			UpdateChartOptions();
			UpdateView();
		}
		this.AppendChartData=function(name, value, unit, redraw, id)
		{
			// fill init chart values.
			var t0 = performance.now();
			var t1;
			var now = Date.now();
			
			if (typeof redraw == 'undefined') 
				redraw = false;
			if (typeof id == 'undefined')
				id = -1;
			
			if (typeof chart_data.datasets[0].info == 'undefined')
				chart_data.datasets[0].info = [];
			
			bDebugMe = false;
			if ( (typeof value) !="number")
				value = parseFloat(value);
			
			if (nStartTime == -1) nStartTime = now;
			total_data.push(value);
			total_info.push({id:id,info:''});
			total_timestamp.push(now);
			var first_item = total_data[0];
			while (total_data.length < MAX_DATA_DISPLAY)
			{
				//total_data.push(value);
				total_data.unshift(first_item);
				total_timestamp.unshift(-1);
				total_info.unshift({info:""});
				nDisplayStartPos = total_data.length - MAX_DATA_DISPLAY;
			}
			if (total_data.length <= MAX_DATA_DISPLAY)
			{
				nDisplayStartPos = 0;
			}
			else if (total_data.length >= MAX_DATA_STORED) 
			{
				total_data.shift();
				total_timestamp.shift();
				total_info.shift();
			}
			else if (!bLockDisplay)
			{
				nDisplayStartPos++;
			} else { // bLockDisplay. check lock id.
				// Locked at ID to index.
				var nIndex=-1;
				if (nLockAtIndex == -1)
					nIndex = total_info.length;
				else
					for (i = 0; i < total_info.length; i++)
					{
						if (typeof(total_info[i].id)=='undefined')
							continue;
						if (total_info[i].id==nLockAtIndex) {
							nIndex = i;
							break;
						}
					}
				nDisplayStartPos = nIndex - (MAX_DATA_DISPLAY) / 2;
				if (nDisplayStartPos < 0) nDisplayStartPos = 0;
				if ((nDisplayStartPos + MAX_DATA_DISPLAY) > total_data.length) 
					nDisplayStartPos = total_data.length - MAX_DATA_DISPLAY;
			}

			while (chart_data.labels.length < (MAX_DATA_DISPLAY))
			{
				chart_data.labels.push("");
			}
			while (chart_data.labels.length > (MAX_DATA_DISPLAY))
			{
				chart_data.labels.pop();
			}
			chart_data.datasets[0].data.length = 0;
			chart_data.datasets[0].info.length = 0;
			var i;
			if (total_data.length < MAX_DATA_DISPLAY)
			{
				for (i = total_data.length; i < MAX_DATA_DISPLAY; i++)
				{
					chart_data.datasets[0].data.push(total_data[0]);
					chart_data.datasets[0].info.push(total_info[0]);
				}
			}
			//if (bDebugMe) console.log("total_data.length="+total_data.length+",nDisplaystartPos="+nDisplayStartPos+"chart_data.datasets[0].data.length="+chart_data.datasets[0].data.length);
			var yMax, yMin;
			yMax = Number.MIN_VALUE;
			yMin = Number.MAX_VALUE;
			for (i=0; i < MAX_DATA_DISPLAY; i++)
			{
				if (total_data[i+nDisplayStartPos]>yMax) yMax = total_data[i+nDisplayStartPos];
				if (total_data[i+nDisplayStartPos]<yMin) yMin = total_data[i+nDisplayStartPos];
			}
			var average = (yMax + yMin)/2;
			var varient = yMax - average;
			var yAxisTop, yAxisBottom;
			
			// 20180612, if yRange is set, use the user defined range.
			if (YType.value == "fix")
			{
				yAxisTop = yRange[0];
				yAxisBottom = yRange[1];
			} else
				
			if (YScaleAllowFloat)
			{
				if (varient == 0 )
				{
					yAxisTop = Math.floor(average+1);
					yAxisBottom = Math.floor(average-1);
					yPrecise = 1;
				}
				else if (varient > 1)
				{
					yAxisTop = Math.ceil(yMax);
					yAxisBottom = Math.floor(yMin);
					chart_options.scales.yAxes[0].stepSize = Math.ceil(varient)/5;
					if (chart_options.scales.yAxes[0].stepSize>=1)
						yPrecise = 0;
					else
						yPrecise = 1;
				}
				else if (varient > 0.1)
				{
					yAxisTop = (Math.ceil(yMax*10))/10;
					yAxisBottom = (Math.floor(yMin*10))/10;
					chart_options.scales.yAxes[0].stepSize = Math.ceil(varient*10)/50;
					yPrecise = 1;
				}
				else if (varient > 0.01)
				{
					yAxisTop = (Math.ceil(yMax*100))/100;
					yAxisBottom = (Math.floor(yMin*100))/100;
					chart_options.scales.yAxes[0].stepSize = Math.ceil(varient*100)/500;
					yPrecise = 2;
				}
				else
				{
					yAxisTop = (Math.ceil(yMax*1000))/1000;
					yAxisBottom = (Math.floor(yMin*1000))/1000;
					chart_options.scales.yAxes[0].stepSize = Math.ceil(varient*1000)/5000;
					yPrecise = 3;
				}
			} else { // only integer allowed.
				yPrecise = 0;
				if (varient == 0 )
				{
					yAxisBottom = Math.floor((average-1)/10)*10;
					yAxisTop = yAxisBottom+10;
				}
				else
				{
					yAxisTop = Math.ceil( (yMax+1)/10)*10;
					yAxisBottom = Math.floor((yMin-1)/10)*10;
				}
			}
			if (yAxisBottom != chart_options.scales.yAxes[0].ticks.min)
			{
				bOptionsChanged = true;
				chart_options.scales.yAxes[0].ticks.min = yAxisBottom;
			}
			if (yAxisTop != chart_options.scales.yAxes[0].ticks.max)
			{
				bOptionsChanged = true;
				chart_options.scales.yAxes[0].ticks.max = yAxisTop;
			}
			chart_options.title.text=name+" "+unit;
			if (redraw)
			{
				if (bOptionsChanged)
				{
					if (ctx == null) return;
					if (oWaveChart == null)
					{
						oWaveChart = new Chart(ctx, {
							type: 'line',
							data: chart_data,
							options: chart_options,
							plugins: [chart_plugins]
						});
					}
					else
					{
						
						oWaveChart.config.options = chart_options;
						oWaveChart.config.data = chart_data;
						oWaveChart.scales["x-axis-0"].options.ticks.fontSize = chart_options.scales.xAxes[0].ticks.fontSize;
						oWaveChart.scales["y-axis-0"].options.ticks.fontSize = chart_options.scales.yAxes[0].ticks.fontSize;
						oWaveChart.options.scales.xAxes["0"].ticks.fontSize = chart_options.scales.xAxes[0].ticks.fontSize;
						oWaveChart.options.scales.yAxes["0"].ticks.fontSize = chart_options.scales.yAxes[0].ticks.fontSize;
						oWaveChart.update();
					}
					oWaveChart.resize(true);
					bOptionsChanged = false;
				}
				UpdateChartOptions();
				UpdateView();
			}
			t1 = performance.now();
		} 
		var bDrag = false;
		var bRedraw=false;
		var bDragMoved = false;
		var nDragStartX=0;
		var nDragStartPos=0;

		function XPageSizeChange(event)
		{
			// 20191016, 修正重選XPage Size後lock失效問題(MAX_DATA_DISPLAY type為string造成)
			_default.XPageSize = MAX_DATA_DISPLAY = parseInt(XPageSizeSelecter.value);
			nDisplayStartPos=total_data.length-MAX_DATA_DISPLAY;
			if (callback != null) callback(_default);
			
			/****************************************************************/
			var first_item = total_data[0];
			while (total_data.length < MAX_DATA_DISPLAY)
			{
				//total_data.push(value);
				total_data.unshift(first_item);
				total_timestamp.unshift(-1);
				total_info.unshift({info:""});
				nDisplayStartPos = total_data.length - MAX_DATA_DISPLAY;
			}
			if (total_data.length <= MAX_DATA_DISPLAY)
			{
				nDisplayStartPos = 0;
			}
			else if (total_data.length >= MAX_DATA_STORED) 
			{
				total_data.shift();
				total_timestamp.shift();
				total_info.shift();
			}
			/*
			// 209190926 修正調整X軸scale後, 最右方一筆data顯示錯誤
			else if (!bLockDisplay)
			{
				nDisplayStartPos++;
			}
			*/
			while (chart_data.labels.length < (MAX_DATA_DISPLAY))
			{
				chart_data.labels.push("");
			}
			while (chart_data.labels.length > (MAX_DATA_DISPLAY))
			{
				chart_data.labels.pop();
			}
			chart_data.datasets[0].data.length = 0;
			chart_data.datasets[0].info.length = 0;
			var i;
			if (total_data.length < MAX_DATA_DISPLAY)
			{
				for (i = total_data.length; i < MAX_DATA_DISPLAY; i++)
				{
					chart_data.datasets[0].data.push(total_data[0]);
					chart_data.datasets[0].info.push(total_info[0]);
				}
			}
			
			/********************************************************************/
			UpdateChartOptions();
			UpdateView();
		}
		function YTypeChange(event)
		{
			if (YType.value == "fix")
			{
				MaxYSelecter.value = yRange[0];
				MinYSelecter.value = yRange[1];
				MaxYSelecter.style.display = "";
				MinYSelecter.style.display = "";
			}
			else
			{
				if (YType.value == "low") YScaleAllowFloat = false;
				else if (YType.value == "high") YScaleAllowFloat = true;
				MaxYSelecter.style.display = "none";
				MinYSelecter.style.display = "none";
			}
			_default.YType = YType.value;
			if (callback != null) callback(_default);
			UpdateChartOptions();
			UpdateView();
		}
		function MaxYChange(event)
		{
			_default.YRange[0]=yRange[0]=MaxYSelecter.value;
			if (callback != null) callback(_default);
			UpdateChartOptions();
			UpdateView();
		}
		function MinYChange(event)
		{
			_default.YRange[1]=yRange[1]=MinYSelecter.value;
			if (callback != null) callback(_default);
			UpdateChartOptions();
			UpdateView();
		}
		
		function UpdateChartOptions()
		{
			var endPos;
			var yMax, yMin;
			endPos = nDisplayStartPos+MAX_DATA_DISPLAY;
			if (endPos > total_data.length) endPos = total_data.length;
			// 209190926:
			// 修正調整Y軸scale後產生的memory leak. (append data only when necessary)
			if (chart_data.datasets[0].data.length < MAX_DATA_DISPLAY )
			{
				chart_data.datasets[0].data = chart_data.datasets[0].data.concat(total_data.slice(nDisplayStartPos, endPos));
				chart_data.datasets[0].info = chart_data.datasets[0].info.concat(total_info.slice(nDisplayStartPos, endPos));
			}
			chart_data.datasets[0].label = name;
			console.log("UpdateChartOptions(): data arry size="+chart_data.datasets[0].data.length);
			yMax = Number.MIN_VALUE;
			yMin = Number.MAX_VALUE;
			for (i=0; i < MAX_DATA_DISPLAY; i++)
			{
				if (total_data[i+nDisplayStartPos]>yMax) yMax = total_data[i+nDisplayStartPos];
				if (total_data[i+nDisplayStartPos]<yMin) yMin = total_data[i+nDisplayStartPos];
			}
			var average = (yMax + yMin)/2;
			var varient = yMax - average;
			var yAxisTop, yAxisBottom;
			
			// 20180612, if yRange is set, use the user defined range.
			if (YType.value == "fix")
			{
				yAxisTop = yRange[0];
				yAxisBottom = yRange[1];
			} else
				
			if (YScaleAllowFloat)
			{
				if (varient == 0 )
				{
					yAxisTop = Math.floor(average+1);
					yAxisBottom = Math.floor(average-1);
					yPrecise = 1;
				}
				else if (varient > 1)
				{
					yAxisTop = Math.ceil(yMax);
					yAxisBottom = Math.floor(yMin);
					chart_options.scales.yAxes[0].stepSize = Math.ceil(varient)/5;
					if (chart_options.scales.yAxes[0].stepSize>=1)
						yPrecise = 0;
					else
						yPrecise = 1;
				}
				else if (varient > 0.1)
				{
					yAxisTop = (Math.ceil(yMax*10))/10;
					yAxisBottom = (Math.floor(yMin*10))/10;
					chart_options.scales.yAxes[0].stepSize = Math.ceil(varient*10)/50;
					yPrecise = 1;
				}
				else if (varient > 0.01)
				{
					yAxisTop = (Math.ceil(yMax*100))/100;
					yAxisBottom = (Math.floor(yMin*100))/100;
					chart_options.scales.yAxes[0].stepSize = Math.ceil(varient*100)/500;
					yPrecise = 2;
				}
				else
				{
					yAxisTop = (Math.ceil(yMax*1000))/1000;
					yAxisBottom = (Math.floor(yMin*1000))/1000;
					chart_options.scales.yAxes[0].stepSize = Math.ceil(varient*1000)/5000;
					yPrecise = 3;
				}
			} else { // only integer allowed.
				yPrecise = 0;
				if (varient == 0 )
				{
					yAxisBottom = Math.floor((average-1)/10)*10;
					yAxisTop = yAxisBottom+10;
				}
				else
				{
					yAxisTop = Math.ceil( (yMax+1)/10)*10;
					yAxisBottom = Math.floor((yMin-1)/10)*10;
				}
			}
			
			if (yAxisBottom != chart_options.scales.yAxes[0].ticks.min)
			{
				bOptionsChanged = true;
				chart_options.scales.yAxes[0].ticks.min = yAxisBottom;
			}
			if (yAxisTop != chart_options.scales.yAxes[0].ticks.max)
			{
				bOptionsChanged = true;
				chart_options.scales.yAxes[0].ticks.max = yAxisTop;
			}
			
			//chart_options.title.text=name+" "+unit;
			if (ctx == null) return;
			var elementWidth = ctx.getBoundingClientRect().width;
			var elementHeight = ctx.getBoundingClientRect().height;
			chart_options.scales.yAxes[0].ticks.fontSize = math.ceil(elementHeight*0.03);
			chart_options.scales.xAxes[0].ticks.fontSize = math.ceil(elementHeight*0.03);
			/******************************************************/

			if (oWaveChart == null)
			{
				oWaveChart = new Chart(ctx, {
					type: 'line',
					data: chart_data,
					options: chart_options,
					plugins: [chart_plugins]
				});
			}
			else
			{
				
				oWaveChart.config.options = chart_options;
				oWaveChart.config.data = chart_data;
				oWaveChart.scales["x-axis-0"].options.ticks.fontSize = chart_options.scales.xAxes[0].ticks.fontSize;
				oWaveChart.scales["y-axis-0"].options.ticks.fontSize = chart_options.scales.yAxes[0].ticks.fontSize;
				oWaveChart.options.scales.xAxes["0"].ticks.fontSize = chart_options.scales.xAxes[0].ticks.fontSize;
				oWaveChart.options.scales.yAxes["0"].ticks.fontSize = chart_options.scales.yAxes[0].ticks.fontSize;
				// 20190924
				oWaveChart.options.scales.yAxes["0"].ticks.min = chart_options.scales.yAxes[0].ticks.min;
				oWaveChart.options.scales.yAxes["0"].ticks.max = chart_options.scales.yAxes[0].ticks.max;
				
				oWaveChart.update();
			}

			oWaveChart.resize(true);
		}
		
		function UpdateView()
		{
			var endPos;
			endPos = nDisplayStartPos+MAX_DATA_DISPLAY;
			if (endPos > total_data.length) endPos = total_data.length;
			// 209190926:
			// 修正調整Y軸scale後產生的memory leak. (append data only when necessary)
			if (chart_data.datasets[0].data.length < MAX_DATA_DISPLAY )
			{
				chart_data.datasets[0].data = chart_data.datasets[0].data.concat(total_data.slice(nDisplayStartPos, endPos));
				chart_data.datasets[0].info = chart_data.datasets[0].info.concat(total_info.slice(nDisplayStartPos, endPos));
			}
			if (oWaveChart)
				oWaveChart.update();
					
			var context = ctx.getContext("2d");
			var elementWidth = ctx.getBoundingClientRect().width;
			var elementHeight = ctx.getBoundingClientRect().height;
			
			var pixelPerItem = elementWidth/total_data.length;
			var left = pixelPerItem*nDisplayStartPos;
			var right = nDisplayStartPos+MAX_DATA_DISPLAY;
			right = left + pixelPerItem*MAX_DATA_DISPLAY;
			context.beginPath();
			context.moveTo(0, elementHeight-2);
			context.lineTo(elementWidth, elementHeight-2);
			context.setLineDash([0]);
			// set line color
			context.strokeStyle = '#00ff00';
			context.stroke();	
			context.beginPath();
			context.moveTo(left, elementHeight-2);
			context.lineTo(right, elementHeight-2);
			context.moveTo(left, elementHeight-3);
			context.lineTo(right, elementHeight-3);
			context.setLineDash([0]);
			context.strokeStyle = '#ff0000';
			context.stroke();
		}
		function DragAndRedraw()
		{
			if (bDrag)
			{
				if (bRedraw)
				{
					chart_data.datasets[0].data.length = 0;
					chart_data.datasets[0].info.length = 0;
					if (total_data.length < MAX_DATA_DISPLAY)
					{
						var i;
						for (i = total_data.length; i < MAX_DATA_DISPLAY; i++)
						{
							chart_data.datasets[0].data.push(total_data[0]);
							chart_data.datasets[0].info.push(total_info[0]);
						}
					}
					UpdateView();
					bReddraw = false;
				}
				setTimeout(function(){DragAndRedraw()}, 100);
			}
			else
			{
				// reset data for proper set tooltip position, used for info in afterdraw plugin.
				chart_data.datasets[0].data.length = 0;
				chart_data.datasets[0].info.length = 0;
				var i;
				if (total_data.length < MAX_DATA_DISPLAY)
				{
					for (i = total_data.length; i < MAX_DATA_DISPLAY; i++)
					{
						chart_data.datasets[0].data.push(total_data[0]);
						chart_data.datasets[0].info.push(total_info[0]);
					}
				}
				UpdateChartOptions();
				UpdateView();
			}
		}
		
		function StartDrag(x)
		{
			bDrag = true;
			nDragStartX = x;
			nDragStartPos = nDisplayStartPos;
			bDragMoved = false;
			setTimeout(function(){DragAndRedraw()}, 100);
			setTimeout(function(){if (!bDragMoved) {bDrag=false;} }, 300);
		}
		function StopDrag(x)
		{
			bLockDisplay = false;
			bDrag = false;
		}
		function MoveDrag(x)
		{
			bDragMoved = true;
			if (bDrag==true)
			{
				var offset = nDragStartX - x;
				var itemWidth = ctx.getBoundingClientRect().width/MAX_DATA_DISPLAY;
				var nNewStartPos = nDragStartPos + Math.floor(offset/itemWidth);
				if (nNewStartPos > (total_data.length-MAX_DATA_DISPLAY) ) nNewStartPos = total_data.length-MAX_DATA_DISPLAY;
				if (nNewStartPos < 0) 
				{
					nNewStartPos = 0;
				}
				if (nNewStartPos == nDisplayStartPos) return;
				
				// update StartPos and redraw.
				nDisplayStartPos = nNewStartPos;
				bRedraw = true;
			}
		}
		function wave_touchstart(event)
		{
			var x=event.changedTouches[0].clientX;
			if(typeof OhaJsInterface !=="undefined") 
			{
				OhaJsInterface.Swift();
			}
			StartDrag(x);
		}
		function wave_touchend(event)
		{
			var x=event.changedTouches[0].clientX;
			StopDrag(x);
		}
		function wave_touchmove(event)
		{
			var x=event.changedTouches[0].clientX;
			MoveDrag(x);
		}
		function init() {
			YType.value = _default.YType;
			yRange[0]=_default.YRange[0];
			yRange[1]=_default.YRange[1];
			MaxYSelecter.options.length = 0;
			MinYSelecter.options.length = 0;
			XPageSizeSelecter.options.length = 0;
			
			var $i;
			var max=-999999;
			for($i=0; $i < _default.XPageSizeSelections.length; $i++)
			{
				var opt = document.createElement("option");
				opt.text = _default.XPageSizeSelections[$i];
				opt.value= _default.XPageSizeSelections[$i];
				XPageSizeSelecter.add(opt, $i);
				if (max < _default.XPageSizeSelections[$i]) max = _default.XPageSizeSelections[$i];
			}
			XPageSizeSelecter.value = MAX_DATA_DISPLAY = _default.XPageSize; // current data per page.
			MAX_DATA_VALUE = max;
			
			for($i=0; $i < _default.MaxYSelections.length; $i++)
			{
				var opt = document.createElement("option");
				opt.text = 'Max:'+_default.MaxYSelections[$i];
				opt.value= _default.MaxYSelections[$i];
				MaxYSelecter.add(opt, $i);
			}
			for($i=0; $i < _default.MinYSelections.length; $i++)
			{
				var opt = document.createElement("option");
				opt.text = 'Min:'+_default.MinYSelections[$i];
				opt.value= _default.MinYSelections[$i];
				MinYSelecter.add(opt, $i);
			}
			
			if (YType.value == "fix")
			{
				MaxYSelecter.value = yRange[0];
				MinYSelecter.value = yRange[1];
				MaxYSelecter.style.display = "";
				MinYSelecter.style.display = "";
			}
			else
			{
				if (YType.value == "low") YScaleAllowFloat = false;
				else if (YType.value == "high") YScaleAllowFloat = true;
				MaxYSelecter.style.display = "none";
				MinYSelecter.style.display = "none";
			}
		}
		init();
        return self;
    };
    
})(jQuery);