(function(_jq){
    var waveview_Html='\
				<select class="YType">\
					<option value="int">Low Precision</option>\
					<option value="float">High Precision</option>\
				</select>\
				<select class="PageSize">\
					<option value="50">50</option>\
					<option value="100">100</option>\
					<option value="200">200</option>\
					<option value="500">500</option>\
					<option value="1000">1000</option>\
				</select>\
                <canvas  class="waveviewPanel"></canvas>\
    ';
    
    var _css="<style>\
        .oha_waveview .PageSize {\
            position:absolute;\
			  top: 0;\
			  right: 0px;\
			  width: 20%;\
			  height:25px;\
			  outline: 0;\
			  font-size:20px;\
			  border-width:1px;\
			  border-style:solid;\
			  border-color:white;\
            background-color:#e0e0e0;\
        }\
        .oha_waveview .YType {\
            position:absolute;\
			  top: 0;\
			  left: 0px;\
			  width: 20%;\
			  height:25px;\
			  outline: 0;\
			  font-size:20px;\
			  border-width:1px;\
			  border-style:solid;\
			  border-color:white;\
            background-color:#e0e0e0;\
        }\
        .oha_waveview .waveviewPanel{\
            height:100%;\
            width:100%;\
            display: inline-block;\
            vertical-align: middle;\
            background-color: white;\
            border-style: solid;\
            border-width: 0;\
            border-color: gray;\
            background-color: #A0A0A0;\
            color: white;\
            text-align: left;\
            overflow: auto;\
            text-overflow: clip;\
            font-size:2.5vh;\
            font-family: \"Courier New\", monospace, Arial, sans-serif;\
			z-index: 0;\
        }\
    </style>";

    _jq.fn.oha_waveview=function(_opt) {
        var self = this;
		var count=0;

        $(this).addClass("oha_waveview");
        $('head').append(_css);
        var _default={
        };
		var chart_data = 
		{
			labels: [],
			datasets: [{
				label: '',
				data: [],
				backgroundColor: 
					'rgba(255, 99, 132, 0.2)'
				,
				borderColor: 
					'rgba(255,99,132,1)'
				,
				borderWidth: 1
			}]
		};
		var total_data = [];
		var nDisplayStartPos=0;
		var bLockDisplay=false;
		var yPrecise=0;
		var chart_options = {
						scales: {
							yAxes: [{
								ticks: {
									userCallback: function(label, index, labels) {
										if (chart_options.scales.yAxes[0].ticks.max === label) {
											return '';
										}
										return parseFloat(label).toFixed(yPrecise);
									}
								},
								gridLines: {
									display: true ,
									color: "#FFFFFF",
									drawTicks:false
								}
							}],
							xAxes: [{
								ticks: {
									beginAtZero:true,
									userCallback: function(label, index, labels) {
										// when the floored value is the same as the value we have a whole number
										if ( (index%6) === 0) {
											return label;
										}
									}
								},
								gridLines: {
									display: true ,
									color: "#FFFFFF",
									drawTicks:false
								}
							}]
						},
						title: { text:''},
						tooltips: {enabled: false},
						// don't draw bezier curve. set tension to 0, 0.4 is for default bezierCurve.
						elements: {
							line: {
								tension: 0
							}
						}
					};
		
		
		Chart.defaults.global.animation.duration = 0;
		Chart.defaults.global.maintainAspectRatio = false;
		Chart.defaults.global.title.display = true;
		Chart.defaults.global.legend.display = false;
		Chart.defaults.global.elements.point.radius = 0;
        Chart.defaults.global.defaultFontColor="#FFFFFF";
		var YScaleAllowFloat=false;
		var MAX_DATA_DISPLAY = 50; // current data per page.
		var MAX_DATA_VALUE = 1000; // max data per page, (max of 50, 100, 200, 500, 1000)
		const MAX_DATA_STORED = 1000000;
		var oWaveChart=null;
		var bOptionsChanged = true;
		var bDebugMe = true;
		
        _jq.extend(_default, _opt);
        $(this).append(waveview_Html);
		var ctx = _jq(self).find(".waveviewPanel")[0];
		/*
		ctx.addEventListener("pointermove", function(event) { wave_pointmove(event);});
		ctx.addEventListener("pointerdown", function(event) { wave_pointdown(event);});
		ctx.addEventListener("pointerup", function(event) { wave_pointup(event);});
		*/
		
		ctx.addEventListener("touchmove", function(event) { wave_touchmove(event);});
		ctx.addEventListener("touchstart", function(event) { wave_touchstart(event);});
		ctx.addEventListener("touchend", function(event) { wave_touchend(event);});
		//ctx.addEventListener("pointerenter", function(event) { wave_pointdown(event);});
		//ctx.addEventListener("pointerleave", function(event) { wave_pointup(event);});
		var page_size = _jq(self).find(".PageSize")[0];
		page_size.addEventListener("change", function(event) { PageSizeChange(event);});
		
		var YType = _jq(self).find(".YType")[0];
		YType.addEventListener("change", function(event) { YTypeChange(event);});
		
		this.Redraw=function()
		{
//			UpdateChartOptions();
//			UpdateView();
		}
		
		this.AppendChartData=function(name, value, unit, redraw)
		{
			// fill init chart values.
			var t0 = performance.now();
			var t1;
			
			if (typeof redraw == 'undefined') 
				redraw = false;
			
			//if (unit=="unit0") bDebugMe = true;
			//else bDebugMe = false;
			
			bDebugMe = false;
			if (typeof value!="number")
				console.log("value is not number, type="+typeof(value));
				value = parseFloat(value);
			
			total_data.push(value);
			var first_item = total_data[0];
			while (total_data.length < MAX_DATA_DISPLAY)
			{
				//total_data.push(value);
				total_data.unshift(first_item);
				nDisplayStartPos = total_data.length - MAX_DATA_DISPLAY;
			}
			if (total_data.length <= MAX_DATA_DISPLAY)
			{
				nDisplayStartPos = 0;
			}
			else if (total_data.length >= MAX_DATA_STORED) 
			{
				total_data.shift();
			}
			else if (!bLockDisplay)
			{
				nDisplayStartPos++;
			}

			while (chart_data.labels.length < (MAX_DATA_DISPLAY))
			{
				chart_data.labels.push("");
			}
			while (chart_data.labels.length > (MAX_DATA_DISPLAY))
			{
				chart_data.labels.pop();
			}
			chart_data.datasets[0].data.length = 0;
			var i;
			if (total_data.length < MAX_DATA_DISPLAY)
			{
				for (i = total_data.length; i < MAX_DATA_DISPLAY; i++)
					chart_data.datasets[0].data.push(total_data[0]);
			}
			var endPos;
			var yMax, yMin;
			endPos = nDisplayStartPos+MAX_DATA_DISPLAY;
			if (endPos > total_data.length) endPos = total_data.length;
			chart_data.datasets[0].data = chart_data.datasets[0].data.concat(total_data.slice(nDisplayStartPos, endPos));
			chart_data.datasets[0].label = name;
			//if (bDebugMe) console.log("total_data.length="+total_data.length+",nDisplaystartPos="+nDisplayStartPos+"chart_data.datasets[0].data.length="+chart_data.datasets[0].data.length);
			yMax = Number.MIN_VALUE;
			yMin = Number.MAX_VALUE;
			for (i=0; i < MAX_DATA_DISPLAY; i++)
			{
				if (total_data[i+nDisplayStartPos]>yMax) yMax = total_data[i+nDisplayStartPos];
				if (total_data[i+nDisplayStartPos]<yMin) yMin = total_data[i+nDisplayStartPos];
			}
			var average = (yMax + yMin)/2;
			var varient = yMax - average;
			var yAxisTop, yAxisBottom;
			
			if (YScaleAllowFloat)
			{
				if (varient == 0 )
				{
					yAxisTop = Math.floor(average+1);
					yAxisBottom = Math.floor(average-1);
					yPrecise = 1;
				}
				else if (varient > 1)
				{
					yAxisTop = Math.ceil(yMax);
					yAxisBottom = Math.floor(yMin);
					chart_options.scales.yAxes[0].stepSize = Math.ceil(varient)/5;
					if (chart_options.scales.yAxes[0].stepSize>=1)
						yPrecise = 0;
					else
						yPrecise = 1;
				}
				else if (varient > 0.1)
				{
					yAxisTop = (Math.ceil(yMax*10))/10;
					yAxisBottom = (Math.floor(yMin*10))/10;
					chart_options.scales.yAxes[0].stepSize = Math.ceil(varient*10)/50;
					yPrecise = 1;
				}
				else if (varient > 0.01)
				{
					yAxisTop = (Math.ceil(yMax*100))/100;
					yAxisBottom = (Math.floor(yMin*100))/100;
					chart_options.scales.yAxes[0].stepSize = Math.ceil(varient*100)/500;
					yPrecise = 2;
				}
				else
				{
					yAxisTop = (Math.ceil(yMax*1000))/1000;
					yAxisBottom = (Math.floor(yMin*1000))/1000;
					chart_options.scales.yAxes[0].stepSize = Math.ceil(varient*1000)/5000;
					yPrecise = 3;
				}
			} else { // only integer allowed.
				yPrecise = 0;
				if (varient == 0 )
				{
					
					yAxisBottom = Math.floor((average-1)/10)*10;
					yAxisTop = yAxisBottom+10;
					
				}
				else
				{
					yAxisTop = Math.ceil( (yMax+1)/10)*10;
					yAxisBottom = Math.floor((yMin-1)/10)*10;
				}
				
			}
			//if (bDebugMe) console.log("yMax="+yMax+",yMin="+yMin+",average="+average+",yAxisTop="+yAxisTop+",yAxisBottom="+yAxisBottom+",varient="+varient, ", step="+chart_options.scales.yAxes[0].fixedStepSize);

			
			if (yAxisBottom != chart_options.scales.yAxes[0].ticks.min)
			{
				bOptionsChanged = true;
				chart_options.scales.yAxes[0].ticks.min = yAxisBottom;
			}
			if (yAxisTop != chart_options.scales.yAxes[0].ticks.max)
			{
				bOptionsChanged = true;
				chart_options.scales.yAxes[0].ticks.max = yAxisTop;
			}
			
			chart_options.title.text=name+" "+unit;
			//chart_options.scales.yAxes[0].scaleLabel.labelString=unit;

			if (redraw)
			{
				//if (count==0 || oWaveChart == null)
				if (bOptionsChanged)
				{
					//var ctx = _jq(self).find(".waveviewPanel")[0];
					if (ctx == null) return;
					oWaveChart = new Chart(ctx, {
						type: 'line',
						data: chart_data,
						options: chart_options
					});

					oWaveChart.resize(true);
					bOptionsChanged = false;
					//console.log("update Y-Axis");
				}
				if (oWaveChart)
					oWaveChart.update();
				var context = ctx.getContext("2d");
				var elementWidth = ctx.getBoundingClientRect().width;
				var elementHeight = ctx.getBoundingClientRect().height;
				
				var pixelPerItem = elementWidth/total_data.length;
				var left = pixelPerItem*nDisplayStartPos;
				var right = nDisplayStartPos+MAX_DATA_DISPLAY;
				right = left + pixelPerItem*MAX_DATA_DISPLAY;
				context.beginPath();
				context.moveTo(0, elementHeight-2);
				context.lineTo(elementWidth, elementHeight-2);
				context.setLineDash([0]);
				// set line color
				context.strokeStyle = '#00ff00';
				context.stroke();	
				context.beginPath();

				context.rect(left, elementHeight-5, right-left, 5);//width+60, height+60);
				context.fillStyle = "#ff0000";
				context.fill();
				//context.setLineDash([0]);
				context.strokeStyle = '#ff0000';
				context.stroke();
			}
			t1 = performance.now();
		} 
		var bDrag = false;
		var bRedraw=false;
		var bDragMoved = false;
		var nDragStartX=0;
		var nDragStartPos=0;

		function PageSizeChange(event)
		{
			MAX_DATA_DISPLAY = page_size.value;
			nDisplayStartPos=total_data.length-MAX_DATA_DISPLAY;
		}
		function YTypeChange(event)
		{
			if (YType.value == "int") YScaleAllowFloat = false;
			else YScaleAllowFloat = true;
			
		}
		function redraw()
		{
			if (bDrag)
			{
				if (bRedraw)
				{
					chart_data.datasets[0].data.length = 0;
					if (total_data.length < MAX_DATA_DISPLAY)
					{
						var i;
						for (i = total_data.length; i < MAX_DATA_DISPLAY; i++)
							chart_data.datasets[0].data.push(total_data[0]);
					}
					var endPos;
					endPos = nDisplayStartPos+MAX_DATA_DISPLAY;
					if (endPos > total_data.length) endPos = total_data.length;
					chart_data.datasets[0].data = chart_data.datasets[0].data.concat(total_data.slice(nDisplayStartPos, endPos));
					if (oWaveChart)
						oWaveChart.update();
					
					var context = ctx.getContext("2d");
					var elementWidth = ctx.getBoundingClientRect().width;
					var elementHeight = ctx.getBoundingClientRect().height;
					
					var pixelPerItem = elementWidth/total_data.length;
					var left = pixelPerItem*nDisplayStartPos;
					var right = nDisplayStartPos+MAX_DATA_DISPLAY;
					right = left + pixelPerItem*MAX_DATA_DISPLAY;
					//if (bDebugMe) 
					//	console.log("pixelPerItem="+pixelPerItem+",left="+left+",right="+right+", nDisplayStartPos="+nDisplayStartPos+",MAX_DATA_DISPLAY="+MAX_DATA_DISPLAY);
					context.beginPath();
					context.moveTo(0, elementHeight-2);
					context.lineTo(elementWidth, elementHeight-2);
					context.setLineDash([0]);
					// set line color
					context.strokeStyle = '#00ff00';
					context.stroke();	
					context.beginPath();
					context.moveTo(left, elementHeight-2);
					context.lineTo(right, elementHeight-2);
					context.moveTo(left, elementHeight-3);
					context.lineTo(right, elementHeight-3);
					context.setLineDash([0]);
					context.strokeStyle = '#ff0000';
					context.stroke();
					
					
					bReddraw = false;
				}
				setTimeout(function(){redraw()}, 100);
			}
		}
		
		function StartDrag(x)
		{
			//if (bDebugMe) { console.log("down event x=", x);}
			bDrag = true;
			nDragStartX = x;
			nDragStartPos = nDisplayStartPos;
			bDragMoved = false;
			setTimeout(function(){redraw()}, 100);
			setTimeout(function(){if (!bDragMoved) {bDrag=false;} }, 300);
		}
		function StopDrag(x)
		{
			//if (bDebugMe) console.log("up");
			bDrag = false;
		}
		function MoveDrag(x)
		{
			bDragMoved = true;
			if (bDrag==true)
			{
				//if (bDebugMe) {console.log("move event x=", x);}
				var offset = nDragStartX - x;
				var itemWidth = ctx.getBoundingClientRect().width/MAX_DATA_DISPLAY;
				var nNewStartPos = nDragStartPos + Math.floor(offset/itemWidth);
				if (nNewStartPos > (total_data.length-MAX_DATA_DISPLAY) ) nNewStartPos = total_data.length-MAX_DATA_DISPLAY;
				if (nNewStartPos < 0) 
				{
					nNewStartPos = 0;
				}
				//if (bDebugMe) console.log("move to x="+x+",offset item="+(offset/itemWidth));
				
				if (nNewStartPos == nDisplayStartPos) return;
				
				// update StartPos and redraw.
				nDisplayStartPos = nNewStartPos;
				bRedraw = true;
			}
		}
		function wave_pointmove(event)
		{
			if (bDrag==true)
			{
				//if (bDebugMe) {console.log("move event obj=%o", event);}
				//event.preventDefault();
				var offset = nDragStartX - event.clientX;
				var itemWidth = ctx.getBoundingClientRect().width/MAX_DATA_DISPLAY;
				var nNewStartPos = nDragStartPos + Math.floor(offset/itemWidth);
				if (nNewStartPos > (total_data.length-MAX_DATA_DISPLAY) ) nNewStartPos = total_data.length-MAX_DATA_DISPLAY;
				if (nNewStartPos < 0) 
				{
					nNewStartPos = 0;
				}
				//if (bDebugMe) console.log("move to x="+event.clientX+",offset item="+(offset/itemWidth));
				
				if (nNewStartPos == nDisplayStartPos) return;
				
				// update StartPos and redraw.
				nDisplayStartPos = nNewStartPos;
				//if (bDebugMe) console.log("redraw chart!!!");

				
				chart_data.datasets[0].data.length = 0;
				if (total_data.length < MAX_DATA_DISPLAY)
				{
					var i;
					for (i = total_data.length; i < MAX_DATA_DISPLAY; i++)
						chart_data.datasets[0].data.push(total_data[0]);
				}
				var endPos;
				endPos = nDisplayStartPos+MAX_DATA_DISPLAY;
				if (endPos > total_data.length) endPos = total_data.length;
				chart_data.datasets[0].data = chart_data.datasets[0].data.concat(total_data.slice(nDisplayStartPos, endPos));
				if (oWaveChart)
					oWaveChart.update();
			}
		}
		
		function wave_pointdown(event)
		{
			//if (bDebugMe) {console.log("down event obj=%o", event);}
			bDrag = true;
			nDragStartX = event.clientX;
			nDragStartPos = nDisplayStartPos;
			
			//console.log("ctx.rect=%o",rect);
		}
		
		function wave_pointup(event)
		{
			//if (bDebugMe) console.log("up");
			bDrag = false;
		}
		
		function wave_touchstart(event)
		{
			var x=event.changedTouches[0].clientX;
			if(typeof OhaJsInterface !=="undefined") 
			{
				OhaJsInterface.Swift();
			}
		//	var rect=ctx.getBoundingClientRect();
		//	console.log("ctx.rect=%o",rect);
			StartDrag(x);
		}
		function wave_touchend(event)
		{
			var x=event.changedTouches[0].clientX;
			StopDrag(x);
		}
		function wave_touchmove(event)
		{
			var x=event.changedTouches[0].clientX;
			MoveDrag(x);
			//if (bDrag) event.preventDefault();
		}

        this.init=function() {
			//var ctx = _jq(self).find(".waveviewPanel")[0];
			//if (ctx == null) return;
        }
		
		
		
		
        return self;
    };
    
})(jQuery);
